'From Squeak3.0 of 4 February 2001 [latest update: #3545] on 21 July 2001 at 3:18:56 pm'!

!ComplexNumbers class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 15:09'!
example01
	"ComplexNumbers example01."
   "Test arithmetic operations with different types of Number."
    | stream complex fraction result c1 |
    stream := WriteStream on:''.
    stream nextPutAll:' Test of ComplexNumber Arithmetic'; cr.
      "create a complex number to use."
    complex := 6i:-7.  fraction := 1/2.
      "Test combinations with integer "
    1 + complex = (complex + 1)
      ifFalse:[ ^self error: self class name,' examplex01 failure'].
    1 - complex = (complex negated + 1)
      ifFalse:[ ^self error: self class name,' examplex01 failure'].
    result := complex - 1.
    2 * complex = (complex * 2)
      ifFalse:[ ^self error: self class name,' examplex01 failure'].
        "the right expression represents a complex number / integer
          and is the steps involved in doing the left expression."
    2 / complex = ((2 * complex conjugate) / ((complex conjugate * complex) real))
      ifFalse:[ ^self error: self class name,' examplex01 failure'].
    result := complex / 1. "will generate an error if not valid"
        "Test combinations with fraction."
    fraction + complex = (complex + fraction)
      ifFalse:[ ^self error: self class name,' examplex01 failure'].
    fraction - complex = (complex negated + fraction)
      ifFalse:[ ^self error: self class name,' examplex01 failure'].
    result := complex - fraction.
    fraction * complex = (complex * fraction)
      ifFalse:[ ^self error: self class name,' examplex01 failure'].
    fraction / complex = ((fraction * complex conjugate) / ((complex conjugate * complex) real))
      ifFalse:[ ^self error: self class name,' examplex01 failure'].
    result := complex / fraction. "will generate an error if not valid"
        "Test combinations with float."
    1.0 + complex = (complex + 1.0)
      ifFalse:[ ^self error: self class name,' examplex01 failure'].
    1.0 - complex = (complex negated + 1.0)
      ifFalse:[ ^self error: self class name,' examplex01 failure'].
    result := complex - 1.0. "will generate an error if not valid"
    2.0 * complex = (complex * 2.0)
      ifFalse:[ ^self error: self class name,' examplex01 failure'].
    2.0 / complex = ((2.0 * complex conjugate) / ((complex conjugate * complex) real))
      ifFalse:[ ^self error: self class name,' examplex01 failure'].
    result := complex / 1.0. "will generate an error if not valid"
        "Test combinations with another complex number."
    c1 := -1 i: -1.
    c1 + complex = (complex + c1)
      ifFalse:[ ^self error: self class name,' examplex01 failure'].
    c1 - complex = (complex negated + c1)
      ifFalse:[ ^self error: self class name,' examplex01 failure'].
    c1 * complex = (complex * c1)
      ifFalse:[ ^self error: self class name,' examplex01 failure'].
    complex / c1 = (1/2i:13/2)
      ifFalse:[ ^self error: self class name,' examplex01 failure'].
    c1 / complex = (1/85i:-13/85)
      ifFalse:[ ^self error: self class name,' examplex01 failure'].
    stream nextPutAll: ' Successful completion of tests'; cr.
    ^stream contents! !

!ComplexNumbers class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 15:11'!
example02
	"ComplexNumbers example02."
   "Answer the stream contents showing use of
    methods #complexRoots:, #raisedTo:, and #forceToZero:"
    | stream roots raised |
    stream := WriteStream on:''.
    stream nextPutAll: '    #complexRoots examples'; cr.
    stream nextPutAll: ' The 3 complex roots of  -8 are:'; cr.
    roots := -8 complexRoots: 3.
    stream nextPutAll: roots printString; cr.
    raised := ((roots at: 1) raisedTo: 3) forceToZero: 1.0e-15.
    stream  nextPutAll: raised printString;
            nextPutAll: ' is first root raisedTo: 3.'; cr.
    raised := ((roots at: 2) raisedTo: 3) forceToZero: 1.0e-15.
    stream  nextPutAll: raised printString;
            nextPutAll: ' is second root raisedTo: 3.'; cr.
    raised := ((roots at: 3) raisedTo: 3) forceToZero: 1.0e-15.
    stream  nextPutAll: raised printString;
            nextPutAll: ' is third root raisedTo: 3.'; cr.
    stream nextPutAll: ' The 3 complex roots of  8 are:'; cr.
    roots := 8 complexRoots: 3.
    stream nextPutAll: roots printString; cr.
    raised := ((roots at: 1) raisedTo: 3) forceToZero: 1.0e-15.
    stream  nextPutAll: raised printString;
            nextPutAll: ' is first root raisedTo: 3.'; cr.
    raised := ((roots at: 2) raisedTo: 3) forceToZero: 1.0e-14.
    stream  nextPutAll: raised printString;
            nextPutAll: ' is second root raisedTo: 3.'; cr.
    raised := ((roots at: 3) raisedTo: 3) forceToZero: 1.0e-15.
    stream  nextPutAll: raised printString;
            nextPutAll: ' is third root raisedTo: 3.'; cr.

    stream nextPutAll: ' The 2 complex roots of  0i:32 are:'; cr.
    roots := (0i:32) complexRoots: 2.
    stream nextPutAll: roots printString; cr.
    raised := ((roots at: 1) raisedTo: 2) forceToZero: 1.0e-15.
    stream  nextPutAll: raised printString;
            nextPutAll: ' is first root raisedTo: 2.'; cr.
    raised := ((roots at: 2) raisedTo: 2) forceToZero: 1.0e-14.
    stream  nextPutAll: raised printString;
            nextPutAll: ' is second root raisedTo: 2.'; cr.

    stream nextPutAll: ' The 4 complex roots of  -8i:13.856406 are:'; cr.
    roots := (-8i:(8*3 sqrt)) complexRoots: 4.
    stream nextPutAll: roots printString; cr.
    raised := ((roots at: 1) raisedTo: 4) forceToZero: 1.0e-15.
    stream  nextPutAll: raised printString;
            nextPutAll: ' is first root raisedTo: 4.'; cr.
    raised := ((roots at: 2) raisedTo: 4) forceToZero: 1.0e-14.
    stream  nextPutAll: raised printString;
            nextPutAll: ' is second root raisedTo: 4.'; cr.
    raised := ((roots at: 3) raisedTo: 4) forceToZero: 1.0e-15.
    stream  nextPutAll: raised printString;
            nextPutAll: ' is third root raisedTo: 4.'; cr.
    raised := ((roots at: 4) raisedTo: 4) forceToZero: 1.0e-15.
    stream  nextPutAll: raised printString;
            nextPutAll: ' is fourth root raisedTo: 4.'; cr.
    ^stream contents! !

!ComplexNumbers class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 15:15'!
example03
	"ComplexNumbers example03."
   "Answer the stream contents showing use of
    methods #exp, #ln, #asVector, #formComplexNumbers,
        and #printWidth:decimal:."
    | stream complexNumbers expectedLn complexNumber  calcLn calcLnExp |
    stream := WriteStream on:''.
    complexNumbers := #( -2i:-2  -2i:1  -1i:-1 -1i:0  0i:-2 0i:-1 0i:1
        0i:2 1i:-1 1i:0 2i:-2 2i:1 ) asVector formComplexNumbers.
    expectedLn := #(1.039721i:-2.356194  0.804719i:2.677945
        0.346574i:-2.356194  0.0i:3.141593  0.693147i:-1.570796
        0.0i:-1.570796  0.0i:1.570796  0.693147i:1.570796  0.346574i:-0.785398
        0.0i:0.0  1.039721i:-0.785398  0.804719i:0.463648 )
            asVector formComplexNumbers.
    stream nextPutAll: '    #exp and #ln examples'; cr.
    stream
        nextPutAll: ' Complex'; cr;
        nextPutAll: '  Number         ln (expected)         ln (computed)       ln exp'  ; cr.
    1 to: complexNumbers size do:[ :j |
        complexNumber := complexNumbers at: j.
        calcLn :=  complexNumber ln.
        calcLnExp := calcLn exp.
        stream
              nextPutAll: (complexNumber printWidth: 3 decimal: 0);
              nextPutAll: '  ';
              nextPutAll: ((expectedLn at: j) printWidth: 10 decimal: 6);
              nextPutAll: (calcLn printWidth: 10 decimal: 6);
              nextPutAll: '   ';
              nextPutAll: (calcLnExp printWidth: 3 decimal: 0); cr. ].
    ^stream contents! !

!ComplexNumbers class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 15:17'!
example04
	"ComplexNumbers example04."
   "Answer the stream contents showing use of
    methods #printRounded:, #printWidth:decimal:, #rounded, #roundTo:
    #truncated, and #truncateTo: ."
    | stream complexNumber  |
    stream := WriteStream on:''.
    complexNumber := 1.999i:1.999.
    stream nextPutAll: '   Misc. examples'; cr.
    stream
      nextPutAll: ' complex number is: ';
        nextPutAll: complexNumber printString; cr;
      nextPutAll: ' complexNumber printRounded: 2  is: ';
        nextPutAll: (complexNumber printRounded: 2); cr;
      nextPutAll: ' complexNumber printWidth: 5 decimal: 3  is: ';
        nextPutAll: (complexNumber printWidth: 5 decimal: 3 ); cr;
      nextPutAll: ' complexNumber rounded is: ';
        nextPutAll: complexNumber rounded printString; cr;
      nextPutAll: ' complexNumber roundTo: 1  is: ';
        nextPutAll: (complexNumber roundTo: 1) printString; cr;
      nextPutAll: ' complexNumber  truncated is: ';
        nextPutAll: complexNumber truncated printString; cr;
      nextPutAll: ' complexNumber truncateTo: 2  is: ';
        nextPutAll: (complexNumber truncateTo: 2) printString; cr.
    ^stream contents! !

!ComplexNumbers class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 15:10'!
exampleReadMe
   "class methods #example01 through #exampleNN demonstrate
some of the features provided by this class.  These examples
are designed to be evaluated in a Workspace with show it(printIt).
For example,  In a workspace evaluate the following line with show it
ComplexNumbers example01

    Each example contains comments explaining the method.
Most of the examples test various operations of ComplexNumber.
"! !

