'From Squeak3.0 of 4 February 2001 [latest update: #3545] on 23 July 2001 at 9:38:29 am'!
SequenceableCollection variableSubclass: #Matrices
	instanceVariableNames: 'dimensionVector offsetVector '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MathPack-Matrices'!

!Matrices commentStamp: 'jpwj 7/19/2001 09:25' prior: 0!
The root class for Matrices


Intance Variables: 
 dimensionVector <Vector> - 2 positions holding the number of rows and number of columns
 offsetVector < > -

!

Matrices variableSubclass: #Matrices2Dimensional
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MathPack-Matrices'!

!Matrices2Dimensional commentStamp: 'jpwj 7/19/2001 08:52' prior: 0!
Matrices2Dimensional holds a operations specific to 2 dimension matrices.!

Matrices2Dimensional variableSubclass: #LowerTriangularMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MathPack-Matrices'!

!LowerTriangularMatrix commentStamp: 'jpwj 7/19/2001 09:02' prior: 0!
LowerTriangularMatrix stores only the lower portion of a 2 dimensional matrix.  This greatly reduces storage and is needed for certain matrix operations.!

Matrices2Dimensional variableSubclass: #Matrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MathPack-Matrices'!
Matrices variableSubclass: #MatrixND
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MathPack-Matrices'!

!MatrixND commentStamp: 'jpwj 7/19/2001 08:48' prior: 0!
MatrixND supports any N Dimensional matrix.!

Matrix variableSubclass: #SquareMatrix
	instanceVariableNames: 'eigenvalues eigenvectors transformation '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MathPack-Matrices'!

!SquareMatrix commentStamp: 'jpwj 7/19/2001 09:11' prior: 0!
SquareMatrix was put in to facilatate support of eigen value and eigen vector operations.

Instance Variables:
eigenvalues < > - 
eigenvectors < > - 
transformation < > - 
!

SquareMatrix variableSubclass: #LuMatrix
	instanceVariableNames: 'signOfDeterminant rowPermutations rowsExchanged '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MathPack-Matrices'!

!LuMatrix commentStamp: 'jpwj 7/19/2001 09:11' prior: 0!
LuMatrix

Instance Variables:
signOfDeterminant < > -
rowPermutations < > - 
rowsExchanged < > -!

Matrices2Dimensional variableSubclass: #TriDiagonalMatrix
	instanceVariableNames: 'eigenvalues eigenvectors transformation '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MathPack-Matrices'!

!TriDiagonalMatrix commentStamp: 'jpwj 7/19/2001 09:02' prior: 0!
TriDiagonalMatrix is specialize to store only the three diagonals of a 2 dimensional matrix.  This greatly reduces storage and is needed for certain matrix operations.
!

Array variableSubclass: #Vector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MathPack-Matrices'!

!Vector commentStamp: 'jpwj 7/20/2001 08:14' prior: 0!
Vector is a subclass of Array for handling 'Arrays' of numbers
The methods added are for numerical computations.
Using the new methods means that the values stored in the Vector MUST
be of class Number(ComplexNumber) or the UndefinedObject (nil).
The UndefinedObject nil is allowed to accomodated the real world
situation of missing values.  nil's are ignored in most computational methods.
  Notes on nil:
Use of lowercase nil creates the desired UndefinedObject in
the following cases:
   - Changing the value of an vector element in an
        Inspector window to nil.
    - at: anInteger put: nil.
    - anVector := #( 1 nil 2 nil ) asVector convertNilSymbols.
Usage of nil that will NOT produce an UndefinedObject.
- anVector := #( 1 nil 2 nil ) asVector.  results in the symbol, nil.
  method convertNilSymbols converts nil symbols to UndefinedObject.

*, +, -, / methods will accept a scalar or another Vector of the
same size as the receiver. The result will be a new vector.
These operations are done element wise when the object is an Vector.
e.g. c := a + b.  c will be an Vector with same size as a.
the contents of c are computed: c at: i put: ((a at: i) + (b at: i)).
when b is an Vector else  c at: i put: ((a at: i) + b ) for each
non-nil element in a.   When a & b are Vectors then nil is stored
in c at: i if either value (a at: i) or (b at: i) is nil.

 !


!Object methodsFor: 'testing' stamp: 'jpwj 7/23/2001 09:22'!
is2DMatrix
	"Answer false bacause only a subclass of Matrices2Dimensional can be a 2D Matrix.
		MathPack jpwj 7/23/01"

	^false! !

!Object methodsFor: 'testing' stamp: 'jpwj 7/23/2001 09:10'!
isAMatrix
	"Answer false because only a subclass of Matrices is aMatrix. MathPack jpwj 7/23/01"

	^false! !

!Object methodsFor: 'testing' stamp: 'jpwj 7/19/2001 15:22'!
isScalar
   "Answer false since any object not belonging to class Number
    or ComplexNumbers is not a scalar. "

    ^false! !

!Object methodsFor: 'testing' stamp: 'jpwj 7/23/2001 09:16'!
isVector
	"Overridden to return true in Vector. MathPack jpwj 7/23/01"

	^false! !


!Collection methodsFor: 'converting' stamp: 'jpwj 7/19/2001 10:38'!
asMatrix  
    "Answer an Matrix containing all the elements of the receiver.  
    Matrix dimensions set to (self size @ 1) [column vector] "  

    | answer index |  

    answer := Matrix new: self size @ 1.  
    index := 1.  
    self do: [ :element |  
        answer at: index put: element.  
        index := index + 1].  
    ^answer! !

!Collection methodsFor: 'converting' stamp: 'jpwj 7/19/2001 10:36'!
asMatrix: aPointOrVector
   "Answer a Matrix dimensioned with dimensions containing all the elements of the receiver."

    | answer index |
    (aPointOrVector isKindOf: Point )
        ifTrue:[
            self size = (aPointOrVector x * aPointOrVector y)
                ifFalse:[ ^self error: self class name,' invalid dimensions'].]
        ifFalse:[ "Assume vector "
            self size = (aPointOrVector dotProduct)
                ifFalse:[ ^self error: self class name,' invalid dimensions'].].
    answer := Matrix new: aPointOrVector.
    index := 1.
    self do: [ :element |
        answer at: index put: element.
        index := index + 1].
    ^answer! !

!Collection methodsFor: 'converting' stamp: 'jpwj 7/19/2001 16:25'!
asVector
   "Answer a Vector containing all the elements of the receiver.
        Added for MathPack jpwj 6/1/89"
    | answer index |
    answer := Vector new: self size.
    index := 1.
    self do: [ :element |
        answer at: index put: element.
        index := index + 1].
    ^answer! !


!Number methodsFor: 'arithmetic' stamp: 'jpwj 7/19/2001 15:49'!
conjugate
   "Answer the conjugate of the receiver which is self for a Real Number
    Added for ComplexNumbers "

    ^self! !

!Number methodsFor: 'arithmetic' stamp: 'jpwj 7/19/2001 11:59'!
pseudoAbs  
   "Answer the absolute value.  Used for linear algebra(matrix)  
    computations.  Same method name used in ComplexNumber"

    ^self abs! !

!Number methodsFor: 'testing' stamp: 'jpwj 7/19/2001 15:48'!
isScalar
   "Answer true since any subclass of Number is mathematically a scalar."

    ^true! !

!Number methodsFor: 'printing' stamp: 'jpwj 7/20/2001 12:01'!
printRounded: numberFractionDigits
   "Answer a string with the ASCII character representation
    of the receiver rounded to numberFractionDigits decimal places.
Extented to allow more than eight decimal places.
Fixed to V286 R1.1 method, last two rounder values had one too many zeros
jpwj 6/1/89
This method still needs some more thought - Squeak may have better ways."
    | rounder |
    numberFractionDigits > 7
        ifFalse: [ rounder := 1/(#(1 10 100 1000 10000
                        100000 1000000 10000000)
                    at: numberFractionDigits + 1).]
        ifTrue:[ rounder := 1 / (10 raisedToInteger: numberFractionDigits + 1)].
    ^(self roundTo: rounder asFloat) printString
        "printFraction: numberFractionDigits"! !


!SequenceableCollection methodsFor: 'enumerating' stamp: 'jpwj 7/19/2001 16:29'!
doIndex: aBlock
    "Answer the receiver.  For each element in the receiver, evaluate aBlock with the argruments: element and index  Added for MathPack "

	"Senders should be replaced with withIndexDo:
	Temporary until correction is made to MathPack."
 
    | index size |
    index := 1.
    size := self size.
    [index > size]
        whileFalse: [
            aBlock value: (self at: index) value: index.
            index := index + 1]! !


!Matrices methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:52'!
dimensionVector 
   "Answer the dimension vector" 
    ^dimensionVector! !

!Matrices methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:54'!
offsetVector
   "Answer the offset vector"
    ^offsetVector! !

!Matrices methodsFor: 'accessing' stamp: 'jpwj 7/23/2001 08:45'!
printLimit
	^self class printLimit! !

!Matrices methodsFor: 'accessing' stamp: 'jpwj 7/21/2001 07:51'!
size
	"Overide inherited size in Collection.  Collection #size as written uses #do: which in turn uses self size - this will cause an infinite loop.  kudo to the person(s) who put in the code to write error log to a file.  do: runs in uninterrptable mode but the LowSpaceDebug.log allow me to debug the problem. jpwj 7/21/2001 07:51 "

	^self basicSize! !

!Matrices methodsFor: 'arithmetic' stamp: 'jpwj 7/23/2001 09:12'!
+ aScalarOrMatrix
   "Answer a new instance of self + aScalarOrMatrix
    Valid objects are: aScalar or aMatrix of correct dimensions
    Method plus: does operation on contents of self."
    | newMatrix |
 "Is aScalarOrMatrix a scalar?"
    aScalarOrMatrix isScalar
      ifTrue: [
        newMatrix := self species new: self dimensions.
        ^self plusScalar: aScalarOrMatrix result: newMatrix   ].
 "Is aScalarOrMatrix a Matrix ?"
   (aScalarOrMatrix isAMatrix)
      ifFalse: [
        ^self error: self class name,' +  with invalid object' ].
 "Is size of Matrix correct?"
    self checkForEqualDimensions: aScalarOrMatrix.
    newMatrix := self species new: self dimensions.
    ^self plusMatrix: aScalarOrMatrix result: newMatrix! !

!Matrices methodsFor: 'arithmetic' stamp: 'jpwj 7/23/2001 09:12'!
- aScalarOrMatrix
   "Answer a new instance of self - aScalarOrMatrix
    Valid objects are: aScalar or aMatrix of correct dimensions
    Method minus: does operation on contents of self."
    | newMatrix |
 "Is aScalarOrMatrix a scalar?"
    aScalarOrMatrix isScalar
      ifTrue: [
        newMatrix := self species new: self dimensions.
        ^self minusScalar: aScalarOrMatrix result: newMatrix ].
 "Is aScalarOrMatrix a Matrix ?"
   (aScalarOrMatrix isAMatrix)
      ifFalse: [
        ^self error: self class name,' -  with invalid object' ].
 "Is size of Matrix correct?"
    self checkForEqualDimensions: aScalarOrMatrix.
    newMatrix := self species new: self dimensions.
    ^self minusMatrix: aScalarOrMatrix result: newMatrix! !

!Matrices methodsFor: 'arithmetic-private' stamp: 'jpwj 7/19/2001 11:51'!
minusMatrix: aMatrix result: answerMatrix
   "Private - for each element in self substract the corresponding element
    in aMatrix placing the result in answerMatrix "
    self doIndex: [ :x :index |
        answerMatrix at: index put: (x - (aMatrix at: index)) ].
    ^answerMatrix! !

!Matrices methodsFor: 'arithmetic-private' stamp: 'jpwj 7/19/2001 11:50'!
minusScalar: aScalar result: answerMatrix
   "Private - substract a scalar from each element in self
    placing the result in answerMatrix "
    self doIndex: [ :x :index |
        answerMatrix at: index put: (x - aScalar) ].
    ^answerMatrix! !

!Matrices methodsFor: 'arithmetic-private' stamp: 'jpwj 7/19/2001 11:54'!
plusMatrix: aMatrix result: answerMatrix 
   "Private - add each element in self with the corresponding element 
    in aMatrix placing the result in answerMatrix " 
    self doIndex: [ :x :index | 
        answerMatrix at: index put: (x + (aMatrix at: index)) ]. 
    ^answerMatrix! !

!Matrices methodsFor: 'arithmetic-private' stamp: 'jpwj 7/19/2001 11:52'!
plusScalar: aScalar result: answerMatrix 
   "Private - add a scalar to each element in self 
    placing the result in answerMatrix " 
    self doIndex: [ :x :index | 
        answerMatrix at: index put: (x + aScalar) ]. 
    ^answerMatrix! !

!Matrices methodsFor: 'arithmetic-private' stamp: 'jpwj 7/19/2001 11:44'!
timesScalar: aScalar
   "Replace self with self * aScalar "
    aScalar isScalar
      ifTrue:[
        ^self timesScalar: aScalar result: self ].
    ^self error: self class name,' timesScalar: invalid object'! !

!Matrices methodsFor: 'arithmetic-private' stamp: 'jpwj 7/19/2001 11:46'!
timesScalar: aScalar  result: answerMatrix 
   "Private - multiple each element in self with aScalar and 
    place the result in answerMatrix " 
    self doIndex: [ :x :index | 
          answerMatrix at: index put: (x * aScalar).]. 
    ^answerMatrix! !

!Matrices methodsFor: 'comparing' stamp: 'jpwj 7/23/2001 09:12'!
= anObject
    "Answer true if the dimensions and contents of two matrices
        are the same.  Check only anObject class and dimension
        here, do remainder of test in super."
    (anObject isAMatrix) "Same class?"
        ifFalse: [^false].
    (self dimensions = anObject dimensions) "Same dimensions"
        ifFalse: [^false].
    ^(super = anObject)! !

!Matrices methodsFor: 'converting' stamp: 'jpwj 7/19/2001 11:53'!
asFloat 
   "Answer a new instance of self with elements asFloat " 
    ^self copy contentsFloat! !

!Matrices methodsFor: 'converting' stamp: 'jpwj 7/19/2001 11:43'!
asMatrix
   "already a full Matrix, answer self.
    some subclasses MUST override this message."
    ^self! !

!Matrices methodsFor: 'converting' stamp: 'jpwj 7/19/2001 11:43'!
contentsFloat 
   "convert contents of receiver to Float values 
    Assumes contents contain only scalar values. 
    Used to speed up calculations." 
    self doIndex:[ :x :index | 
        self at: index put: x asFloat.]! !

!Matrices methodsFor: 'copying' stamp: 'jpwj 7/19/2001 11:49'!
shallowCopy 
   "Answer a new instance with the same contents" 
    ^(self species basicNew:  self size) 
            dimensions: self dimensionVector offsets: self offsetVector; 
            contents: self! !

!Matrices methodsFor: 'private' stamp: 'jpwj 7/19/2001 11:51'!
dimensions: dVector offsets: oVector
   "Private - set the instance variables "
    dimensionVector := dVector.
    offsetVector := oVector! !

!Matrices methodsFor: 'testing' stamp: 'jpwj 7/19/2001 11:45'!
checkForEqualDimensions: aMatrix
 "Answer an error if dimensions are unequal else answer true."
    (self dimensionVector = aMatrix dimensionVector)
      ifFalse: [
        ^self error: 'Matrices must be same dimensions' ].
    ^true! !

!Matrices methodsFor: 'testing' stamp: 'jpwj 7/23/2001 09:18'!
isAMatrix
	"Answer true because any of my subclasses is a Matrix."

	^true! !

!Matrices methodsFor: 'testing' stamp: 'jpwj 7/23/2001 09:31'!
isReal 
    "Answer true if all elements of the receiver are only of class Number" 

    1 to: self size do:[ :i | 
        ((self at: i) isNumber) 
            ifFalse:[ ^false ]. ]. 
    ^true! !

!Matrices methodsFor: 'unclassified' stamp: 'jpwj 7/19/2001 11:50'!
contents: aFixedSizeCollection 
   "replace the contents of self with values in aFixedSizeCollection. 
    Values in aFixedSizeCollection Must be in row order." 
    self replaceFrom: 1 to: self size with: aFixedSizeCollection! !


!Matrices class methodsFor: 'aaReadMe' stamp: 'jpwj 7/19/2001 12:20'!
aaReadMe
   "Matrices is the Root class for holding the various forms of Matrices.
Class contains the instance variables(dimensionVector,offsetVector)
and other methods common to all matrices.

Instance
Variables           Description
---------           -----------
dimensionVector  vector containing the dimensions of the matrix.
                    vector size the number of dimensions for the matrix.
                    e.g. (5,4) is a 2 dimensional matrix 5 rows by 4 cols.
offsetVector     vector holding the offsets into the matrix.  Use to compute
                an elements index.  Not used for 2 dimensional matrices.
"! !

!Matrices class methodsFor: 'constants' stamp: 'jpwj 7/23/2001 08:39'!
printLimit
	"Answer anInteger that will be used to limit the amount the amount of a large matrix that will be printed.  A full page (8.5''x11'') is roughly 1980 charactors"

	^4000! !

!Matrices class methodsFor: 'instance creation' stamp: 'jpwj 7/19/2001 12:19'!
new 
   "Invalid message for this class and all subclasses" 
    ^self error: 'Invalid message for this class and all subclasses'! !


!Matrices2Dimensional methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 09:54'!
appendAtBottom: anArrayOrMatrix
   "Answer a new instance containing contents of self with
    anArrayOrMatrix contents appended bottom.
    anArray size MUST equal self rows (i.e. column vector).
    aMatrix rows MUST equal self rows."

    | newRows newMatrix tempMatrix |

    ( anArrayOrMatrix isKindOf: Array )
      ifTrue:[ tempMatrix := anArrayOrMatrix asMatrix: 1 @ self columns ]
      ifFalse:[tempMatrix := anArrayOrMatrix asMatrix ].
    ( self columns = tempMatrix columns )
      ifFalse:[ ^self error: self class name,' columns not equal' ].
    newRows := self rows + tempMatrix rows.
    newMatrix := Matrix new: newRows @ self columns.
   "Transfer contents of self"
    1 to: self rows do:[ :r |
        newMatrix copyRow: r fromMatrix: self toRow: r. ].
    "Transfer contents of tempMatrix"
    1 to: tempMatrix rows do:[ :r |
        newMatrix copyRow: r fromMatrix: tempMatrix
                    toRow: (self rows + r )].
    ^newMatrix! !

!Matrices2Dimensional methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 09:48'!
appendAtRight: anArrayOrMatrix
   "Answer a new instance containing contents of self with anArrayOrMatrix contents appended to the right side.
    anArray size MUST equal self rows (i.e. column vector)
    aMatrix rows MUST equal self rows."

    | targetColumn newColumns newMatrix tempMatrix |
    tempMatrix := anArrayOrMatrix asMatrix.
    ( self rows = tempMatrix rows )
      ifFalse:[ ^self error: self class name,' rows not equal' ].
    newColumns := self columns + tempMatrix columns.
    newMatrix := Matrix new: self rows @ newColumns.
    targetColumn := self columns + 1.
   "Transfer contents of self"
    1 to: self rows do:[ :r |
        newMatrix copyRow: r fromMatrix: self toRow: r.
        newMatrix copyRow: r fromMatrix: tempMatrix toRow: r at: targetColumn. ].

    ^newMatrix! !

!Matrices2Dimensional methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 09:57'!
columns   
   "Answer the number of columns."

    ^(dimensionVector at: 2)! !

!Matrices2Dimensional methodsFor: 'accessing' stamp: 'jpwj 7/23/2001 09:15'!
deleteColumn: anIntegerOrArray
   "Answer a new instance with the specific rows deleted."
    | columnArray newColumns newMatrix columnIndex |
    ( anIntegerOrArray isInteger )
      ifTrue:[ "store in columnArray"
        columnArray := Array with: anIntegerOrArray ]
      ifFalse:[ "assume Array"
        columnArray := anIntegerOrArray ].
    newColumns := self columns - columnArray size.
    newMatrix := Matrix new: self rows @ newColumns.
   "Transfer contents of self less columns to delete"
    columnIndex := 0.
    1 to: self columns do:[ :c |
      ( columnArray indexOf: c ) = 0
        ifTrue:[
          columnIndex := columnIndex + 1.
          newMatrix columnAt: columnIndex put:( self columnAt: c). ]. ].
    ^newMatrix! !

!Matrices2Dimensional methodsFor: 'accessing' stamp: 'jpwj 7/23/2001 09:15'!
deleteRow: anIntegerOrArray
   "Answer a new instance with the specific rows deleted."
    | rowArray newRows newMatrix rowIndex |
    ( anIntegerOrArray isInteger )
      ifTrue:[ "store in rowArray"
        rowArray := Array with: anIntegerOrArray ]
      ifFalse:[ "assume anArray"
        rowArray := anIntegerOrArray ].
    newRows := self rows - rowArray size.
    newMatrix := Matrix new: newRows @ self columns.
   "Transfer contents of self less rows to delete"
    rowIndex := 0.
    1 to: self rows do:[ :r |
      ( rowArray indexOf: r ) = 0
        ifTrue:[
          rowIndex := rowIndex + 1.
          newMatrix copyRow: r fromMatrix: self toRow: rowIndex. ]. ].
    ^newMatrix! !

!Matrices2Dimensional methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 09:36'!
dimensions
	"Answer the receiver dimensions as aPoint (rows by columns)."

	^ self rows @ self columns! !

!Matrices2Dimensional methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 09:27'!
insertColumns: numberOfColumns before: columnNumber
   "Answer a new instance with numberOfColumns inserted before columnNumber."

    | newMatrix newColumns columnIndex |

    newColumns := self columns + numberOfColumns.
    newMatrix := Matrix new: self rows @ newColumns.
   "Transfer preceding columns"
    columnIndex := 0.
    1 to: columnNumber - 1 do:[ :c |
        columnIndex := columnIndex + 1.
        newMatrix columnAt: columnIndex put: (self columnAt: c) ].
    columnIndex := numberOfColumns + columnNumber - 1.
    columnNumber to: self columns do:[ :c |
        columnIndex := columnIndex + 1.
        newMatrix columnAt: columnIndex put: (self columnAt: c) ].
    ^newMatrix! !

!Matrices2Dimensional methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 09:31'!
insertRows: numberOfRows above: rowNumber
   "Answer a new instance with numberOfRows inserted above rowNumber"

    | newRows newMatrix rowIndex |

    newRows := self rows + numberOfRows.
    newMatrix := Matrix new: newRows @ self columns.
   "Copy in preceding rows from self "
    rowIndex := 0.
    1 to: rowNumber - 1 do:[ :r |
        rowIndex := rowIndex + 1.
        newMatrix copyRow: r fromMatrix: self toRow: rowIndex. ].
    rowIndex := numberOfRows + rowNumber - 1.
   "Copy remaining rows from self "
    rowNumber to: self rows do:[ :r |
        rowIndex := rowIndex + 1.
        newMatrix copyRow: r fromMatrix: self toRow: rowIndex. ].
    ^newMatrix! !

!Matrices2Dimensional methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 09:46'!
row: rowNumber col: columnNumber extractSubMatrix: dimensions
   "Answer the subMatrix of dimensions from self where rowNumber,columnNumber define the upper left corner"
    | newMatrix rowIndex end |

    newMatrix := Matrix new: dimensions.
    rowIndex := rowNumber.
    end := columnNumber + newMatrix columns - 1.
   "Transfer selected contents of self"
    1 to: newMatrix rows do:[ :r |
        newMatrix copyRow: rowIndex fromMatrix: self
                start: columnNumber stop: end toRow: r.
        rowIndex := rowIndex + 1. ].

    ^newMatrix! !

!Matrices2Dimensional methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 09:56'!
rows 
   "Answer the number of rows." 

	^(dimensionVector at: 1)! !

!Matrices2Dimensional methodsFor: 'arithmetic' stamp: 'jpwj 7/19/2001 09:57'!
mutate  
   "Answer  
      element if size equal 1  
      vector if either dimension is 1  
      self otherwise "  
    self size = 1  
        ifTrue:[ ^self at: 1 ].  
    ( self rows = 1 or: [ self columns = 1 ] )  
        ifTrue:[ ^self asVector ].  
    ^self! !

!Matrices2Dimensional methodsFor: 'private' stamp: 'jpwj 7/19/2001 09:53'!
checkColumnIndex: columnNumber   
   "Answer an error for an invalid columnNumber"   
    (columnNumber < 1 or:[ columnNumber > self columns])   
      ifTrue: [ ^self columnIndexError ].   
    ^columnNumber! !

!Matrices2Dimensional methodsFor: 'private' stamp: 'jpwj 7/19/2001 09:55'!
checkRowIndex: rowNumber   
   "Answer an error for an invalid rowNumber"

    (rowNumber < 1 or:[ rowNumber > self rows])   
      ifTrue: [ ^self rowIndexError ].   

    ^rowNumber! !

!Matrices2Dimensional methodsFor: 'private' stamp: 'jpwj 7/19/2001 09:52'!
columnIndexError   
   "Answer an error "

	^self error: self class name,   
            ' invalid column number/index.'! !

!Matrices2Dimensional methodsFor: 'private' stamp: 'jpwj 7/19/2001 09:53'!
rowIndexError   
   "Answer an error "
 
	^self error: self class name,   
            ' invalid row number/index.'! !

!Matrices2Dimensional methodsFor: 'private' stamp: 'jpwj 7/19/2001 09:23'!
rows: numberOfRows byColumns: numberOfColumns   
   "Private - set the instance variable dimensionVector   
    the dimensions of the Matrix. (numberOfRows by numberOfColumns" 

    dimensionVector := Vector new: 2.  
    dimensionVector at: 1 put: numberOfRows.   
    dimensionVector at: 2 put: numberOfColumns! !

!Matrices2Dimensional methodsFor: 'testing' stamp: 'jpwj 7/23/2001 09:23'!
is2DMatrix
	"Answer true bacause any of my subclasses are a  2D Matrix"

	^true! !

!Matrices2Dimensional methodsFor: 'testing' stamp: 'jpwj 7/19/2001 09:45'!
isSymmetric
	"Answer an error, should be implemented by subClass.  
	subClass should answer a Boolean.
	A matrix is symmetric if it equals its transpose.  i.e. dimensions are N @ N
		and element(i,j) = element(j,i) for i=1..N and j=1..N "

	^ self subclassResponsibility! !

!Matrices2Dimensional methodsFor: 'unclassified' stamp: 'jpwj 7/19/2001 09:19'!
row: rowNumber col: columnNumber placeSubMatrix: aMatrix
   "Replace the subMatrix in self with aMatrix where rowNumber,columnNumber define the upper left corner"
    | rowIndex |
    rowIndex := 1.
   "Transfer selected contents of self"
    rowNumber to: rowNumber + aMatrix rows - 1 do:[ :r |
        self copyRow: rowIndex fromMatrix: aMatrix
               toRow: r at: columnNumber.
        rowIndex := rowIndex + 1. ]
! !


!LowerTriangularMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:26'!
appendAtBottom: anArrayOrMatrix
   "Answer a new instance containing contents of self with
    anArrayOrMatrix contents appended to the right side.
    anArray size MUST equal self rows (i.e. column vector).
    aMatrix rows MUST equal self rows."
    ^self asMatrix appendAtBottom: anArrayOrMatrix! !

!LowerTriangularMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:23'!
appendAtRight: anArrayOrMatrix
   "Answer a new instance containing contents of self with
    anArrayOrMatrix contents appended to the right side.
    anArray size MUST equal self rows (i.e. column vector).
    aMatrix rows MUST equal self rows."
    ^self asMatrix appendAtRight: anArrayOrMatrix! !

!LowerTriangularMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:26'!
columnAt: columnNumber
   "Answer a vector containing the values in column, columnNumber"
    | column |
    column := Vector new: self rows.
    1 to: self rows do:[ :r |
        column at: r put: (self row: r col: columnNumber) ].
    ^column! !

!LowerTriangularMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:26'!
deleteColumn: anIntegerOrArray
   "Answer a new instance with the specific rows deleted."
    ^self asMatrix deleteColumn: anIntegerOrArray! !

!LowerTriangularMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:23'!
deleteRow: anIntegerOrArray
   "Answer a new instance with the specific rows deleted."
    ^self asMatrix deleteRow: anIntegerOrArray! !

!LowerTriangularMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:15'!
insertColumns: numberOfColumns before: columnNumber
   "Answer a new instance with numberOfColumns inserted before columnNumber."
    ^self asMatrix insertColumns: numberOfColumns before: columnNumber! !

!LowerTriangularMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:19'!
insertRows: numberOfRows above: rowNumber
   "Answer a new instance with numberOfRows inserted above rowNumber"
    ^self asMatrix insertRows: numberOfRows above: rowNumber! !

!LowerTriangularMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:21'!
row: nRow col: nCol   
   "Answer the element at rowNumber (nRow) and columnNumber(nCol)"   
    ^(self at: (self convertPoint: nRow @ nCol) )! !

!LowerTriangularMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:24'!
row: rowNumber col: columnNumber extractSubMatrix: dimensions
   "Answer the subMatrix of dimensions from self where
    rowNumber,columnNumber define the upper left corner"
    ^self asMatrix row: rowNumber col: columnNumber extractSubMatrix: dimensions

! !

!LowerTriangularMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:22'!
row: rowNumber col: columnNumber placeSubMatrix: aMatrix
   "Replace the subMatrix in self with aMatrix where
    rowNumber,columnNumber define the upper left corner"
    ^self asMatrix row: rowNumber col: columnNumber placeSubMatrix: aMatrix
! !

!LowerTriangularMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:22'!
row: nRow col: nCol put: aValue   
   "Store aValue at rowNumber (nRow) and columnNumber(nCol)   
    answer aValue"   
    self at: (self convertPoint: nRow @ nCol)  put: aValue.   
    ^aValue! !

!LowerTriangularMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:18'!
rowAt: rowNumber
   "Answer a vector containing the row values at rowNumber"
    | row |
    row := Vector new: self columns.
    1 to: self columns do:[ :c |
        row at: c put: (self row: rowNumber col: c) ].
    ^row! !

!LowerTriangularMatrix methodsFor: 'arithmetic' stamp: 'jpwj 7/23/2001 09:35'!
* aScalarVectorOrMatrix
   "Answer the result of self * aScalarVectorOrMatrix.
    result may be Scalar, Vector, Matrix.
    Select the appropiate method for the class of aScalarVectorOrMatrix
    timesScalar: is provided to operation on contents of self."
    | newMatrix |
 "aScalarVectorOrMatrix is a Scalar?"
    aScalarVectorOrMatrix isScalar
      ifTrue: [
        newMatrix := self species new: self dimensions.
        ^self timesScalar: aScalarVectorOrMatrix result: newMatrix ].
  "aScalarVectorOrMatrix is an Vector?
        vector treated as Matrix of dimensions (vector size @ 1)"
    ( aScalarVectorOrMatrix isVector )
      ifTrue:[ ^self asMatrix timesVector: aScalarVectorOrMatrix ].
  "aScalarVectorOrMatrix is aMatrix"
   (aScalarVectorOrMatrix is2DMatrix)
      ifFalse: [
        ^self error: self class name,' *  an invalid object' ].
    ^self asMatrix timesMatrix: aScalarVectorOrMatrix! !

!LowerTriangularMatrix methodsFor: 'arithmetic' stamp: 'jpwj 7/23/2001 09:35'!
+ aScalarOrMatrix
   "When aScalarOrMatrix is:
        aScalar answer self asMatrix + aScalarOrMatrix
        aMatrix of same class answer self plusMatrix:result:
        aMatrix of different class
                answer self asMatrix + aScalarOrMatrix asMatrix"
    | newMatrix |
  "Is aScalarOrMatrix a scalar?"
    aScalarOrMatrix isScalar
      ifTrue: [
        ^self asMatrix + aScalarOrMatrix].
  "Is aScalarOrMatrix a Matrix ?"
   (aScalarOrMatrix is2DMatrix)
      ifFalse: [
        ^self error: self class name,' +  with invalid object' ].
  "Is size of Matrix correct?"
    self checkForEqualDimensions: aScalarOrMatrix.
  "aScalarOrMatrix class same class as self?"
    self class ==  aScalarOrMatrix class
      ifFalse:[ "coerce both objects to full Matrix"
        ^self asMatrix + aScalarOrMatrix asMatrix ].
  "Same class"
    newMatrix := self species new: self dimensions.
    ^self plusMatrix: aScalarOrMatrix result: newMatrix! !

!LowerTriangularMatrix methodsFor: 'arithmetic' stamp: 'jpwj 7/23/2001 09:30'!
- aScalarOrMatrix
   "When aScalarOrMatrix is:
        aScalar answer self asMatrix - aScalarOrMatrix
        aMatrix of same class answer self plusMatrix:result:
        aMatrix of different class
                answer self asMatrix - aScalarOrMatrix asMatrix"
    | newMatrix |
  "Is aScalarOrMatrix a scalar?"
    aScalarOrMatrix isScalar
      ifTrue: [
        ^self asMatrix - aScalarOrMatrix].
  "Is aScalarOrMatrix a Matrix ?"
   (aScalarOrMatrix is2DMatrix)
      ifFalse: [
        ^self error: self class name,' -  with invalid object' ].
  "Is size of Matrix correct?"
    self checkForEqualDimensions: aScalarOrMatrix.
  "aScalarOrMatrix class same class as self?"
    self class ==  aScalarOrMatrix class
      ifFalse:[ "coerce both objects to full Matrix"
        ^self asMatrix - aScalarOrMatrix asMatrix ].
  "Same class"
    newMatrix := self species new: self dimensions.
    ^self minusMatrix: aScalarOrMatrix result: newMatrix! !

!LowerTriangularMatrix methodsFor: 'arithmetic-private' stamp: 'jpwj 7/19/2001 11:20'!
minus: aScalarOrMatrix
   "If aScalarOrMatrix class not equal self class then
    invalid message because class of reciever must change"
    self class ==  aScalarOrMatrix class
      ifFalse:[
        ^self error: 'Class of argument is incorrect.' ].
   "Is size of Matrix correct?"
    self checkForEqualDimensions: aScalarOrMatrix.
    ^self minusMatrix: aScalarOrMatrix result: self! !

!LowerTriangularMatrix methodsFor: 'arithmetic-private' stamp: 'jpwj 7/19/2001 11:17'!
plus: aScalarOrMatrix
   "If aScalarOrMatrix class not equal self class then
    invalid message because class of reciever must change"
    self class ==  aScalarOrMatrix class
      ifFalse:[
        ^self error: 'Invalid argument for the reciever.'. ].
   "Is size of Matrix correct?"
    self checkForEqualDimensions: aScalarOrMatrix.
    ^self plusMatrix: aScalarOrMatrix result: self! !

!LowerTriangularMatrix methodsFor: 'converting' stamp: 'jpwj 7/19/2001 11:21'!
asMatrix   
   "Answer a full Matrix with the elements from   
    the LowerTriangular matrix stored appropiately"   
    | newMatrix index |   
    newMatrix := Matrix new: self rows @ self rows.   
    index := 0.   
    1 to: self rows do:[ :r |   
      1 to: r  do:[ :c |   
          index := index + 1.   
          newMatrix row: r col: c put: (self at: index).   
          newMatrix row: c col: r put: (self at: index).].].   
    ^newMatrix! !

!LowerTriangularMatrix methodsFor: 'converting' stamp: 'jpwj 7/19/2001 11:27'!
convertPoint: aPoint   
    "Answer the index into the LowerTriangularMatrix for the   
    element at nRow and nCol"   
    | index nRow nCol |   
    nRow := aPoint x.   
    nCol := aPoint y.   
    nCol > nRow   
      ifTrue: [ index := ((nCol * (nCol - 1)) / 2 ) + nRow.]   
      ifFalse:[ index := ((nRow * (nRow - 1)) / 2 ) + nCol ].   
    ^index! !

!LowerTriangularMatrix methodsFor: 'printing' stamp: 'jpwj 7/23/2001 08:52'!
printOn: aStream
	"Append the ASCII representation of the receiver to aStream.
		Method does not prevent prevent infinite recursion."
    | limit index |
    self isEmpty
        ifTrue: [
            nil printOn: aStream.
            ^self ].
    limit := aStream position + self printLimit.
    aStream nextPut: $(; cr; space.
    index := 0.
    1 to: self rows do: [ :r |
    1 to:         r do: [ :c |
        (aStream position > limit)
            ifTrue: [
                '...etc...)' printOn: aStream.
                ^self].
        index := index + 1.
        (self at: index) printOn: aStream.
        aStream space].
      aStream cr; space.].
    aStream nextPut: $)! !

!LowerTriangularMatrix methodsFor: 'printing' stamp: 'jpwj 7/19/2001 11:18'!
printOn: aStream width: width decimal: places
    "Print matrix row by row."
    | index |
    aStream cr.
    index := 0.
    1 to: self rows do:[ :r |
      1 to: r  do:[ :c |
         index := index + 1.
         (self at: index) printOn: aStream
                            width: width decimal: places.].
      aStream cr.].! !

!LowerTriangularMatrix methodsFor: 'testing' stamp: 'jpwj 7/19/2001 11:25'!
isSymmetric   
   "Answer true since by definition a LowerTriangularMatrix is symmetric"

    ^true! !


!Matrices2Dimensional class methodsFor: 'aaReadme' stamp: 'jpwj 7/19/2001 12:09'!
aaReadMe
   "Matrices2Dimensional hierarchically groups all two dimensional
matrix types and common methods. ALL subclasses should implement
the class method  #new:.
*** Access elements by method #row:col: or #row:col:put:   ***
*** Access a row by method #rowAt: or #rowAt:put.          ***
*** Access a column by method #columnAt: or #columnAt:put: ***
    The above access methods are recommended since #at: and #at:put:
are not overridden.  Use of #at: is the linear position in the matrix.
    SquareMatrix is the a special case of Matrix
where the number of rows equals the number of columns(N x N).
SquareMatrix provides a convenient way to group all methods restricted the
the N x N case of a matrix.  The Matrix creation method new:
creates a SquareMatrix if appropiate otherwise a Matrix.  i.e.
it is sufficient to use Matrix new: or Matrix new:contents and let
the method worry about whether the matrix is square or not.
   subClasses LowerTriangularMatrix, TriDiagonalMatrix are provided
primarily for storage reduction for large Matrices.  Therefore, they
MUST be converted to full matrices with #asMatrix for computations"! !

!Matrices2Dimensional class methodsFor: 'converting' stamp: 'jpwj 7/23/2001 09:14'!
convertToPoint: integerPointOrVector 
   "Answer a Point. " 
    (integerPointOrVector isPoint) 
        ifTrue:[ ^integerPointOrVector ]. 
    (integerPointOrVector isInteger) 
        ifTrue:[ ^integerPointOrVector @ integerPointOrVector]. 
    (integerPointOrVector isKindOf: Array) 
        ifTrue:[ ^(integerPointOrVector at: 1) 
                @ (integerPointOrVector at: 2)]. 
    ^self error: self class name,' new: withInvalidObject'! !


!LowerTriangularMatrix class methodsFor: 'aaReadme' stamp: 'jpwj 7/19/2001 12:14'!
aaReadMe
   "LowerTriangularMatrix is used as an efficient way of storing
a symmetric matrix.  i.e. only elements of the lower half and
the diagonal are required thus reducing memory requirements.
A full symmetric matrix will look like
 1  2  4  7      Note the elements in the upper half correpsond to
 2  3  5  8   the elements in the lower half.  e(i,j) = e(j,i)
 4  5  6  9   for i=1,4 and j=1,4 and i not equal j.
 7  8  9 10
    To use any valid methods in class hierarchy Matrix, first expand the
LowerTriangularMatrix to a full Matrix with method #asMatrix
and use the appropiate method.  e.g. to get the luDecomposition do
result := (lower asMatrix) luDecomposition.
   where lower is a LowerTriangularMatrix
   result is luDecomposition matrix
The above technique avoids recoding methods specifically for the
special case of a lower triangular matrix. "! !

!LowerTriangularMatrix class methodsFor: 'instance creation' stamp: 'jpwj 7/19/2001 12:13'!
new: aPointOrInteger
   "Answer a new instance. Dimensions must be N by N"
    | aPoint size newMatrix n |
    aPoint := Matrices2Dimensional convertToPoint: aPointOrInteger.
    aPoint x = aPoint y
      ifFalse:[^self error: self class name,' MUST be N @ N'].
    n := aPoint x.
    size := (n * (n - 1)) / 2 + n.
    newMatrix := super basicNew: size.
    newMatrix rows: n byColumns: n.
    ^newMatrix! !

!LowerTriangularMatrix class methodsFor: 'instance creation' stamp: 'jpwj 7/19/2001 12:13'!
new: aPoint contents: aCollection   
    "Return new instance of LowerTriangularMatrix set to the   
    dimensions of aPoint with the contents of aCollection.   
    aCollection must be of size (N * (N-1)) / 2 + N   
    where N = rows = columns.  The elements in aCollection MUST be   
    in row order.  e.g. for N = 3, the respective positions of   
    elements in the matrix to the aCollection are:   
     (1,1) (2,1) (2,2) (3,1) (3,2) (3,3)"   
    ^(self new: aPoint ) contents: aCollection! !


!Matrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 10:14'!
columnAt: columnNumber   
    "answer a Vector containing the elements of the column at columnNumber as an Vector"   
    | column index |   
    column := Vector new: self rows.   
    index := columnNumber.   
    1 to: self rows   
      do: [ :i | column at: i put: (self at: index).   
                 index := index + self columns. ].   
    ^column! !

!Matrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 10:07'!
columnAt: columnNumber put: aCollection   
    "replace an existing column with aCollection at column number.   
     aCollection must be of size = columns"   
    | index |   
    index := columnNumber.   
    1 to: self rows   
      do: [ :i | self at: index put: ( aCollection at: i ).   
                 index := index + self columns. ]! !

!Matrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 10:01'!
indexOfMaximumAbsoluteValueOnColumn: columnNumber1   
        from: startIndex to: endIndex   
   "Answer the index of the maximum absolute value on columnNumber   
      in the range startIndex to endIndex"   
    | index1 maxAbs indexOfMaximum |   
    index1 := self computeIndexFor: startIndex at: columnNumber1.   
    self checkRowIndex: endIndex.   
    maxAbs := (self at: index1) pseudoAbs.   
    indexOfMaximum := startIndex.   
    startIndex + 1 to: endIndex do:[ :i |   
        index1 := index1 + self columns.   
        maxAbs < ( (self at: index1) pseudoAbs )   
            ifTrue:[   
                maxAbs := (self at: index1) pseudoAbs.   
                indexOfMaximum := i. ]   
        ].   
    ^indexOfMaximum! !

!Matrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 10:32'!
indexOfMaximumAbsoluteValueOnRow: rowNumber1   
        from: startIndex to: endIndex   
   "Answer the index of the maximum absolute value on rowNumber   
      in the range startIndex to endIndex"   
    | index1 maxAbs indexOfMaximum |   
    index1 := self computeIndexFor: rowNumber1 at: startIndex.   
    self checkColumnIndex: endIndex.   
    maxAbs := (self at: index1) pseudoAbs.   
    indexOfMaximum := startIndex.   
    startIndex + 1 to: endIndex do:[ :i |   
        index1 := index1 + 1.   
        maxAbs < ( (self at: index1) pseudoAbs )   
            ifTrue:[   
                maxAbs := (self at: index1) pseudoAbs.   
                indexOfMaximum := i. ]   
        ].   
    ^indexOfMaximum! !

!Matrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 10:00'!
row: rowNumber col: columnNumber   
    "Return element at the position given row & column number   
        These should be integer values."   

    ^(self at: ( ((rowNumber - 1 ) * self columns) + columnNumber))! !

!Matrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 10:31'!
row: rowNumber col: columnNumber put: anObject   
    "Answer anObject after putting it in the given row & column number   
        rowNumber & columnNumber should be integer values."   
    self at: (self convertPoint: rowNumber @ columnNumber)   
        put: anObject.   
    ^anObject! !

!Matrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 10:25'!
row: rowNumber1 exchange: rowNumber2   
    "Exchange rowNumber1 with rowNumber2"   
    | index1 index2 temp |   
      "compute starting indices for row numbers"   
    index1 := self convertPoint: (rowNumber1 @ 1).   
    index2 := self convertPoint: (rowNumber2 @ 1).   
    1 to: self columns do:[ :i |   
        temp := self at: index1.   
        self at: index1 put: (self at: index2).   
        self at: index2 put: temp.   
        index1 := index1 + 1.   
        index2 := index2 + 1.].! !

!Matrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 10:25'!
rowAt: rowNumber   
    "answer the row at rowNumber as aVector."   
    | row index |   
    row := Vector new: self columns.   
    index := ((rowNumber - 1 ) * self columns) + 1.   
    1 to: self columns   
      do: [ :i | row at: i put: (self at: index).   
                 index := index + 1. ].   
    ^row! !

!Matrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 10:13'!
rowAt: rowNumber put: aCollection   
    "replace existing row at rowNumber with aCollection   
     aCollection must be of size = rows"   
    | index |   
    index := self convertPoint: rowNumber @ 1.   
    1 to: self columns   
      do: [ :i | self at: index put: (aCollection at: i ).   
                 index := index + 1. ]! !

!Matrix methodsFor: 'arithmetic' stamp: 'jpwj 7/23/2001 09:24'!
* aScalarVectorOrMatrix
   "Answer the result of self * aScalarVectorOrMatrix.
    result may be Scalar, Vector, Matrix.
    Select the appropiate method for the class of aScalarVectorOrMatrix
    timesScalar: is provided to operation on contents of self."
    | newMatrix |
 "aScalarVectorOrMatrix is a Scalar?"
    aScalarVectorOrMatrix isScalar
      ifTrue: [
        newMatrix := Matrix new: self dimensions.
        ^self timesScalar: aScalarVectorOrMatrix result: newMatrix ].
  "aScalarVectorOrMatrix is an Vector?
        vector treated as Matrix of dimensions (vector size @ 1)"
    ( aScalarVectorOrMatrix isVector )
      ifTrue:[ ^self timesVector: aScalarVectorOrMatrix ].
  "aScalarVectorOrMatrix is aMatrix"
   (aScalarVectorOrMatrix is2DMatrix)
      ifFalse: [
        ^self error: self class name,' *  an invalid object' ].
    ^self timesMatrix: aScalarVectorOrMatrix! !

!Matrix methodsFor: 'arithmetic' stamp: 'jpwj 7/19/2001 10:31'!
crossProduct: vector1 with: vector2   
    "Answer self with the crossproduct of two vector's as the new contents.   
    vector1 size MUST equal rows. vector2 size MUST equal columns   
    vector1 and vector2 can be the same vector   
        when vector size = rows = columns"   
    | index |   
    (vector1 size = self rows and: [ vector2 size = self columns ])   
      ifFalse: [   
        ^self error: self class name, 'crossProduct: vector(s) wrong size.' ].   
    index := 0.   
    1 to: self rows do: [ :i |   
        1 to: self columns do: [ :j |   
            index := index + 1.   
            self at: index put: ((vector1 at: i) * (vector2 at: j)) ]. ].! !

!Matrix methodsFor: 'arithmetic' stamp: 'jpwj 7/19/2001 10:06'!
dotProductConjugateOfColumn: columnNumber1 with: columnNumber2   
    from: startIndex to: endIndex   
   "Answer the dotProduct of a columnNumber1 with columnNumber2   
     from startIndex to endIndex.  columnNumber1 can equal columnNumber2.   
     The conjugate value of elements in columnNumber1 are used."   
    | index1  index2 sumOfProducts |   
    index1 := self computeIndexFor: startIndex at: columnNumber1.   
    self checkRowIndex: endIndex.   
    index2 := self computeIndexFor: startIndex at: columnNumber2.   
    sumOfProducts := 0.   
    ( endIndex - startIndex + 1 ) timesRepeat: [   
        sumOfProducts := sumOfProducts +   
          ( (self at: index1) conjugate * (self at: index2) ).   
        index1 := index1 + self columns.   
        index2 := index2 + self columns. ].   
    ^sumOfProducts! !

!Matrix methodsFor: 'arithmetic' stamp: 'jpwj 7/19/2001 10:08'!
dotProductConjugateOfRow: rowNumber1 with: rowNumber2   
    from: startIndex to: endIndex   
   "Answer the dotProduct of a rowNumber1 with rowNumber2   
     from startIndex to endIndex.  rowNumber1 can equal rowNumber2.   
     The conjugate of elements in rowNumber1 is used."   
    | index1  index2 sumOfProducts |   
    index1 := self computeIndexFor: rowNumber1 at: startIndex.   
    self checkColumnIndex: endIndex.   
    index2 := self computeIndexFor: rowNumber2 at: startIndex.   
    sumOfProducts := 0.   
    ( endIndex - startIndex + 1 ) timesRepeat: [   
        sumOfProducts := sumOfProducts +   
          ( (self at: index1) conjugate * (self at: index2) ).   
        index1 := index1 + 1.   
        index2 := index2 + 1. ].   
    ^sumOfProducts! !

!Matrix methodsFor: 'arithmetic' stamp: 'jpwj 7/19/2001 10:32'!
dotProductOfColumn: columnNumber1 with: columnNumber2   
    from: startIndex to: endIndex   
   "Answer the dotProduct of a columnNumber1 with columnNumber2   
     from startIndex to endIndex.  columnNumber1 can equal columnNumber2."   
    | index1  index2 sumOfProducts |   
    index1 := self computeIndexFor: startIndex at: columnNumber1.   
    self checkRowIndex: endIndex.   
    index2 := self computeIndexFor: startIndex at: columnNumber2.   
    sumOfProducts := 0.   
    ( endIndex - startIndex + 1 ) timesRepeat: [   
        sumOfProducts := sumOfProducts +   
          ( (self at: index1) * (self at: index2) ).   
        index1 := index1 + self columns.   
        index2 := index2 + self columns. ].   
    ^sumOfProducts! !

!Matrix methodsFor: 'arithmetic' stamp: 'jpwj 7/19/2001 10:33'!
dotProductOfRow: rowNumber1 with: rowNumber2   
    from: startIndex to: endIndex   
   "Answer the dotProduct of a rowNumber1 with rowNumber2   
     from startIndex to endIndex.  rowNumber1 can equal rowNumber2."   
    | index1  index2 sumOfProducts |   
    index1 := self computeIndexFor: rowNumber1 at: startIndex.   
    self checkColumnIndex: endIndex.   
    index2 := self computeIndexFor: rowNumber2 at: startIndex.   
    sumOfProducts := 0.   
    ( endIndex - startIndex + 1 ) timesRepeat: [   
        sumOfProducts := sumOfProducts +   
          ( (self at: index1) * (self at: index2) ).   
        index1 := index1 + 1.   
        index2 := index2 + 1. ].   
    ^sumOfProducts! !

!Matrix methodsFor: 'arithmetic' stamp: 'jpwj 7/19/2001 10:11'!
sumAbsoluteValuesOnColumn: columnNumber1 from: startIndex to: endIndex   
   "Answer the sum of the absolute values on columnNumber   
      from startIndex to endIndex"   
    | index1 sum |   
    index1 := self computeIndexFor: startIndex at: columnNumber1.   
    self checkRowIndex: endIndex.   
    sum := 0.   
    ( endIndex - startIndex + 1 ) timesRepeat: [   
        sum := sum + ( (self at: index1) pseudoAbs ).   
        index1 := index1 + self columns. ].   
    ^sum! !

!Matrix methodsFor: 'arithmetic' stamp: 'jpwj 7/19/2001 10:10'!
sumAbsoluteValuesOnRow: rowNumber1 from: startIndex to: endIndex   
   "Answer the sum of the absolute values on rowNumber   
      from startIndex to endIndex"   
    | index1 sum |   
    index1 := self computeIndexFor: rowNumber1 at: startIndex.   
    self checkColumnIndex: endIndex.   
    sum := 0.   
    ( endIndex - startIndex + 1 ) timesRepeat: [   
        sum := sum + ( (self at: index1) pseudoAbs ).   
        index1 := index1 + 1. ].   
    ^sum! !

!Matrix methodsFor: 'arithmetic-private' stamp: 'jpwj 7/23/2001 09:25'!
minus: aScalarOrMatrix  
   "Answer self with contents replaced by self - aScalarOrMatrix,  
    where aScalarOrMatrix is either a scalar  
                   or another matrix of correct size."  

 "Is aScalarOrMatrix a scalar?"  
    aScalarOrMatrix isScalar  
      ifTrue: [  
        ^self minusScalar: aScalarOrMatrix result: self ].  
 "Is aScalarOrMatrix a Matrix ?"  
   (aScalarOrMatrix isAMatrix)  
      ifFalse: [  
        ^self error: self class name,' -  with invalid object' ].  
 "Is size of Matrix correct?"  
    self checkForEqualDimensions: aScalarOrMatrix.  
    ^self minusMatrix: aScalarOrMatrix result: self! !

!Matrix methodsFor: 'arithmetic-private' stamp: 'jpwj 7/19/2001 10:08'!
onColumn: columnNumber1 addColumn: columnNumber2 times: aScalar   
        from: startIndex to: endIndex   
   "To each element on columnNumber1 add the corresponding element   
    from columnNumber2 times aScalar from startIndex to endIndex   
        where startIndex <= endIndex.   
    i.e. c1 := c1 + (c2 * aScalar)   
    To subtract the value (c2 * aScalar) use aScalar negated"   
    | index1  index2 |   
    index1 := self computeIndexFor: startIndex at: columnNumber1.   
    self checkRowIndex: endIndex.   
    index2 := self computeIndexFor: startIndex at: columnNumber2.   
    ( endIndex - startIndex + 1 ) timesRepeat: [   
        self at: index1 put:   
            ((self at: index1) + ((self at: index2) * aScalar) ).   
        index1 := index1 + self columns.   
        index2 := index2 + self columns. ]! !

!Matrix methodsFor: 'arithmetic-private' stamp: 'jpwj 7/19/2001 10:15'!
onColumn: columnNumber1 times: aScalar from: startIndex to: endIndex   
   "Multiple each element on columnNumber by aScalar   
    from startIndex to endIndex where startIndex <= endIndex.   
    Division is accomplish by using aScalar reciprocal."   
    | index1 |   
    index1 := self computeIndexFor: startIndex at: columnNumber1.   
    self checkRowIndex: endIndex.   
    ( endIndex - startIndex + 1 ) timesRepeat: [   
        self at: index1 put: ((self at: index1) * aScalar ).   
        index1 := index1 + self columns. ].! !

!Matrix methodsFor: 'arithmetic-private' stamp: 'jpwj 7/19/2001 10:30'!
onRow: rowNumber1 addRow: rowNumber2 times: aScalar   
        from: startIndex to: endIndex   
   "To each element on rowNumber1 add the corresponding element   
    from rowNumber2 times aScalar from startIndex to endIndex   
        where startIndex <= endIndex.  i.e. r1 := r1 + (r2 * aScalar)   
    To subtract the value (r2 * aScalar) use aScalar negated   "   
    | index1  index2 |   
    index1 := self computeIndexFor: rowNumber1 at: startIndex.   
    self checkColumnIndex: endIndex.   
    index2 := self computeIndexFor: rowNumber2 at: startIndex.   
    ( endIndex - startIndex + 1 ) timesRepeat: [   
        self at: index1 put:   
          ( (self at: index1) + ((self at: index2) * aScalar) ).   
        index1 := index1 + 1.   
        index2 := index2 + 1. ]! !

!Matrix methodsFor: 'arithmetic-private' stamp: 'jpwj 7/19/2001 10:06'!
onRow: rowNumber1 times: aScalar from: startIndex to: endIndex   
   "Multiple each element on rowNumber by aScalar   
    from startIndex to endIndex where startIndex <= endIndex.   
    Division is accomplish by using aScalar reciprocal  "   
    | index1 |   
    index1 := self computeIndexFor: rowNumber1 at: startIndex.   
    self checkColumnIndex: endIndex.   
    ( endIndex - startIndex + 1 ) timesRepeat: [   
        self at: index1 put: ((self at: index1) * aScalar ).   
        index1 := index1 + 1. ]! !

!Matrix methodsFor: 'arithmetic-private' stamp: 'jpwj 7/19/2001 10:29'!
onRowSumProductsNegated: rowNumber downCol: columnNumber   
        initialValue: value   
        from: startIndex to: endIndex   
   "Answer 0 if startIndex > endIndex  Else   
    Answer sum := sum - ( self(rowNumber,k) * self(k,columnNumber)   
        for k := startIndex to: endIndex.   
    i.e. move across the row and down the column."   
    | index1  index2 sum |   
    sum := value.   
    startIndex > endIndex   
        ifTrue:[ ^sum ].   
    index1 := self computeIndexFor: rowNumber at: startIndex.   
    self checkColumnIndex: endIndex.   
    index2 := self computeIndexFor: startIndex at: columnNumber.   
    ( endIndex - startIndex + 1 ) timesRepeat: [   
        sum := sum - ( (self at: index1) * (self at: index2) ).   
        index1 := index1 + 1.   
        index2 := index2 + self columns. ].   
    ^sum! !

!Matrix methodsFor: 'arithmetic-private' stamp: 'jpwj 7/23/2001 09:26'!
plus: aScalarOrMatrix  
   "Answer self with contents replaced by self + aScalarOrMatrix,  
    where aScalarOrMatrix is either a scalar  
                   or another matrix of correct size."  
 
"Is aScalarOrMatrix a scalar?"  
    aScalarOrMatrix isScalar  
      ifTrue: [  
        ^self plusScalar: aScalarOrMatrix result: self ].  
 "Is aScalarOrMatrix a Matrix ?"  
   (aScalarOrMatrix isAMatrix)  
      ifFalse: [  
        ^self error: self class name,' +  with invalid object' ].  
 "Is size of Matrix correct?"  
    self checkForEqualDimensions: aScalarOrMatrix.  
    ^self plusMatrix: aScalarOrMatrix result: self! !

!Matrix methodsFor: 'arithmetic-private' stamp: 'jpwj 7/19/2001 10:12'!
timesMatrix: aMatrix  
   "Private - Answer result of self * aMatrix  
    result can be a scalar, vector, or matrix depending on dimensions of self and aMatrix" 

    | newMatrix col  row |  

  "check for correct dimensions"  
   (self columns = aMatrix rows)  
      ifFalse: [  
        ^self error: self class name,' *  aMatrix with invalid dimensions' ].  
    newMatrix := Matrix rows: self rows columns: (aMatrix columns).  
    1 to: newMatrix columns do: [ :c |  
      col := aMatrix columnAt: c.  
        1 to: newMatrix rows do: [ :r |  
          row := self rowAt: r.  
          newMatrix row: r col: c  
                    put: (col dotProduct: row) ].  ].  
    ^newMatrix mutate! !

!Matrix methodsFor: 'arithmetic-private' stamp: 'jpwj 7/19/2001 10:30'!
timesVector: aVector  
   "Private - Answer the result of self * aVector  
    aVector treated as columnVector  
        i.e. matrix dimensioned (aVector size @ 1)"  
    "Check size "  
    self columns = aVector size  
      ifFalse: [  
          ^self error: self class name,' * wrong Vector size.' ].  
    ^self timesMatrix: (aVector asMatrix)! !

!Matrix methodsFor: 'converting' stamp: 'jpwj 7/19/2001 10:28'!
convertIndex: anInteger   
   "Answer aPoint representing the row @ column position given by anInteger index." 

    | row column |   

    ((anInteger > self size) or: [anInteger < 1 ] )   
      ifTrue: [ ^self error: 'Invalid index value'].   
    row := (anInteger - 1) // self columns + 1.   
    column := anInteger - ( (row - 1) * self columns ).

    ^row @ column! !

!Matrix methodsFor: 'converting' stamp: 'jpwj 7/19/2001 10:27'!
convertPoint: aPoint   
   "Answer the linear index into the Matrix given by the row @ column values of aPoint"

    ^self computeIndexFor: aPoint x at: aPoint y! !

!Matrix methodsFor: 'copying' stamp: 'jpwj 7/19/2001 10:15'!
copyRow: sourceRowNumber fromMatrix: aMatrix
         start: columnNumber1 stop: columnNumber2
         toRow: targetRowNumber
   "Copy from columnNumber1 to columnNumber2 on sourceRowNumber
    from aMatrix into targetRowNumber in self."
    | index1 index2 |
    index1 := self computeIndexFor: targetRowNumber at: 1.
    index2 := aMatrix computeIndexFor: sourceRowNumber at: columnNumber1.
    columnNumber1 to: columnNumber2 do:[ :col |
        self at: index1 put: (aMatrix at: index2).
        index1 := index1 + 1.
        index2 := index2 + 1. ].! !

!Matrix methodsFor: 'copying' stamp: 'jpwj 7/19/2001 10:09'!
copyRow: sourceRowNumber
    fromMatrix: aMatrix
         toRow: targetRowNumber
   "Copy sourceRowNumber from aMatrix into targetRowNumber in self."
    | index1 index2 |
    index1 := self computeIndexFor: targetRowNumber at: 1.
    index2 := aMatrix computeIndexFor: sourceRowNumber at: 1.
    1 to: aMatrix columns do:[ :col |
        self at: index1 put: (aMatrix at: index2).
        index1 := index1 + 1.
        index2 := index2 + 1. ]! !

!Matrix methodsFor: 'copying' stamp: 'jpwj 7/19/2001 10:31'!
copyRow: sourceRowNumber
    fromMatrix: aMatrix
         toRow: targetRowNumber
            at: targetColumn
   "Copy sourceRowNumber from aMatrix into targetRowNumber in self
    starting at targetColumn. "
    | index1 index2 |
    index1 := self computeIndexFor: targetRowNumber at: targetColumn.
    index2 := aMatrix computeIndexFor: sourceRowNumber at: 1.
    1 to: aMatrix columns do:[ :col |
        self at: index1 put: (aMatrix at: index2).
        index1 := index1 + 1.
        index2 := index2 + 1. ]! !

!Matrix methodsFor: 'printing' stamp: 'jpwj 7/23/2001 08:40'!
printOn: aStream
    "Append the ASCII representation of the receiver to aStream.
		Method does not prevent prevent infinite recursion."
    | limit index |
    self isEmpty
        ifTrue: [
            nil printOn: aStream.
            ^self ].
    limit := aStream position + self printLimit.
    aStream nextPut: $(; cr; space.
    index := 0.
    1 to:    self rows do: [ :r |
    1 to: self columns do: [ :c |
        (aStream position > limit)
            ifTrue: [
                '...etc...)' printOn: aStream.
                ^self].
        index := index + 1.
        (self at: index) printOn: aStream.
        aStream space].
        r ~= self rows
            ifTrue: [aStream cr; space. ]. ].
    aStream nextPut: $).
! !

!Matrix methodsFor: 'printing' stamp: 'jpwj 7/19/2001 10:14'!
printOn: aStream width: width decimal: places
    "Print matrix row by row."
    | newline |
    aStream cr.
    newline := 0.
    self do: [ :x |
        x printOn: aStream width: width decimal: places.
        newline := newline + 1.
        newline = self columns
            ifTrue:[ newline := 0. aStream cr.]. ]! !

!Matrix methodsFor: 'private' stamp: 'jpwj 7/19/2001 10:29'!
computeIndexFor: rowNumber at: columnNumber   
   "Answer the index into self for the element given   
      by rowNumber at columnNumber."   
    self checkRowIndex: rowNumber.   
    self checkColumnIndex: columnNumber. 

    ^((rowNumber - 1 ) * self columns) + columnNumber! !

!Matrix methodsFor: 'testing' stamp: 'jpwj 7/19/2001 10:26'!
isSymmetric   
   "Answer false since the matrix Must be N x N.   
    An N x N matrix must class SquareMatrix"   

    ^false! !

!Matrix methodsFor: 'unclassified' stamp: 'jpwj 7/19/2001 10:28'!
column: number1 exchange: number2   
    "Exchange column number1 with column number2"   
    | index1 index2 temp |   
      "compute starting indices for row numbers"   
    index1 := self convertPoint: (1 @ number1).   
    index2 := self convertPoint: (1 @ number2).   
    1 to: self rows do:[ :i |   
        temp := self at: index1.   
        self at: index1 put: (self at: index2).   
        self at: index2 put: temp.   
        index1 := index1 + self columns.   
        index2 := index2 + self columns. ]! !

!Matrix methodsFor: 'unclassified' stamp: 'jpwj 7/19/2001 10:08'!
transpose   
    "answer a new Matrix that is the Transpose of self"   
    | transpose index1 index2 |   
    transpose := Matrix new: self columns @ self rows.   
    index2 := 1.   
    1 to: self columns do: [ :c |   
        index1 := c.   
      1 to: self rows do: [ :r |   
        transpose at: index2 put: (self at: index1).   
        index1 := index1 + self columns.   
        index2 := index2 + 1.   
            ]. ].   
    ^transpose! !


!Matrix class methodsFor: 'aaReadme' stamp: 'jpwj 7/19/2001 12:05'!
aaReadMe
   "Additional access methods may be easily added to mimic
the access protocol of other implementations of Matrix.
Caution - do not overide #at: or #at:put:.  Add a method such as
atPoint: aPoint which will convert aPoint into the correct index
value for use with #at: index "! !

!Matrix class methodsFor: 'instance creation' stamp: 'jpwj 7/23/2001 09:24'!
identity: anIntegerOrPoint
   "Answer anN by anN indentity matrix"
    | newMatrix aVector anN |
    (anIntegerOrPoint isPoint )
      ifTrue: [ anN := anIntegerOrPoint x. ]
      ifFalse:[ anN := anIntegerOrPoint .].
    anN > 1
      ifFalse:[ ^self error: self class name,
        ' identity valid ONLY for anN > 1' ].
    newMatrix := (Matrix new: anN @ anN) atAllPut: 0.
    aVector := (Vector new: anN) atAllPut: 1.
    newMatrix diagonal: aVector.
    ^newMatrix! !

!Matrix class methodsFor: 'instance creation' stamp: 'jpwj 7/23/2001 09:25'!
new: integerPointOrVector
   "Answer a new instance.  Dimensions set to:
    integerPointOrVector x by integerPointOrVector y for a Point;
    integerPointOrVector by 1 for an Integer.  Defaulting the
    dimensions to anInteger @ 1 allows #collect:, #reject:
    #select: to work unaltered and return a matrix."
    | aPoint newMatrix |
    (integerPointOrVector isInteger)
        ifTrue:[ aPoint := integerPointOrVector @ 1 ].
    (integerPointOrVector isPoint)
        ifTrue:[ aPoint := integerPointOrVector ].
    (integerPointOrVector isKindOf: Array)
        ifTrue:[
            integerPointOrVector size = 2
                ifFalse:[ ^self error: self class name,
                    ' new: invalid dimension'].
            aPoint := (integerPointOrVector at: 1)
                      @ (integerPointOrVector at: 2)].
    aPoint x = aPoint y
      ifTrue:[ ^SquareMatrix new: aPoint ].
    newMatrix := super new: ( aPoint x * aPoint y ).
    newMatrix rows: aPoint x byColumns: aPoint y.
    ^newMatrix! !

!Matrix class methodsFor: 'instance creation' stamp: 'jpwj 7/19/2001 12:04'!
new: aPoint contents: aCollection   
    "Return new instance of Matrix set to the dimension of aPoint   
        with the contents of aCollection"   
    ^(self new: aPoint ) contents: aCollection! !

!Matrix class methodsFor: 'instance creation' stamp: 'jpwj 7/19/2001 12:04'!
rows: nRows columns: nCols   
    "Return new instance of Matrix set to nRows by Ncols   
        contents are nil."   
    ^self new: nRows @ nCols! !

!Matrix class methodsFor: 'instance creation' stamp: 'jpwj 7/19/2001 12:04'!
rows: nRows columns: nCols contents: aCollection   
    "Return new instance set to nRows by Ncols   
        contents will be copied from aCollection.     
        aCollection MUST be in row ordered    
        and of correct size (nRows * nCols)"   
    ^(self new: nRows @ nCols ) contents: aCollection! !


!MatrixND methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 10:49'!
dimensions
        "Answer the value of dimensions."
    ^dimensionVector! !

!MatrixND methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 10:44'!
elementAt: aVector
   "Answer the element at position given by the indices in aVector"
    ^self at: (self computeIndex: aVector)! !

!MatrixND methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 10:44'!
matrixAt: indicesVector
   "Answer a matrix extracted from self. The desired matrix orientation
    is designated by two zero positions in the indicesVector"
    | index index1 index2 d1 d2 matrix workIndices |
    index1 := indicesVector indexOf: 0.
    d1 := dimensionVector at: index1.
    index1 + 1 to: indicesVector size do:[ :i |
      (indicesVector at: i) = 0
        ifTrue:[
          index2 := i.
          d2 := dimensionVector at: index2.]. ].
    matrix := Matrix new: d1 @ d2.
    workIndices := indicesVector copy.
    index := 0.
    1 to: d1 do:[ :j |
        workIndices at: index1 put: j.
      1 to: d2 do:[ :i |
        workIndices at: index2 put: i.
        index := index + 1.
        matrix at: index put: (self elementAt: workIndices)].].
    ^matrix! !

!MatrixND methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 10:50'!
matrixAt: indicesVector put: aMatrix
   "Place aMatrix in self. The desired matrix orientation
    is designated by two zero positions in the indicesVector.
    aMatrix is assumed to be two dimensional"
    | index index1 index2 d1 d2 workIndices |
    index1 := indicesVector indexOf: 0.
    d1 := dimensionVector at: index1.
    index1 + 1 to: indicesVector size do:[ :i |
      (indicesVector at: i) = 0
        ifTrue:[
          index2 := i.
          d2 := dimensionVector at: index2.]. ].
    workIndices := indicesVector copy.
    index := 0.
    1 to: d1 do:[ :j |
        workIndices at: index1 put: j.
      1 to: d2 do:[ :i |
        workIndices at: index2 put: i.
        index := index + 1.
        self elementAt: workIndices put: (aMatrix at: index)].].
    ^aMatrix! !

!MatrixND methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 10:46'!
rowAt: indicesVector
   "Answer a vector containing the row.  The desired row orientation
    is designated by the a zero position in the indicesVector"
    | index size vector workIndices |
    index := indicesVector indexOf: 0.
    size := dimensionVector at: index.
    vector := Vector new: size.
    workIndices := indicesVector copy.
    1 to: size do:[ :i |
      workIndices at: index put: i.
      vector at: i put: (self elementAt: workIndices)].
    ^vector! !

!MatrixND methodsFor: 'printing' stamp: 'jpwj 7/23/2001 08:42'!
printOn: aStream
	"Append the ASCII representation of the receiver to aStream.
		Method does not prevent prevent infinite recursion."
    | limit index dN dN1 last groups |
    self isEmpty
        ifTrue: [
            nil printOn: aStream.
            ^self ].
    limit := aStream position + self printLimit.
    aStream nextPut: $(; cr; space.
    last := dimensionVector size.
    dN := dimensionVector at: last.
    dN1 := dimensionVector at: last - 1.
    index := 0.
    groups := 1.
    1 to: last - 2 do:[ :i |
        groups := groups * (dimensionVector at: i) ].
    1 to: groups do:[ :g |
      1 to: dN1 do: [ :r |
        1 to: dN do: [ :c |
            (aStream position > limit)
                ifTrue: [
                    '...etc...)' printOn: aStream.
                    ^self].
            index := index + 1.
            (self at: index) printOn: aStream.
            aStream space].
          aStream cr; space. ].
        g = groups
          ifFalse:[ aStream cr; space. ].
      ].
    aStream nextPut: $).! !

!MatrixND methodsFor: 'printing' stamp: 'jpwj 7/19/2001 10:48'!
printOn: aStream width: width decimal: places
    "Print MatrixND elements(numeric) a matrix at time "
    | index dN dN1 last groups |
    aStream cr.
    index := 0.
    last := dimensionVector size.
    dN := dimensionVector at: last.
    dN1 := dimensionVector at: last - 1.
    index := 0.
    groups := 1.
    1 to: last - 2 do:[ :i |
        groups := groups * (dimensionVector at: i) ].
    1 to: groups do:[ :g |
      1 to: dN1 do: [ :r |
        1 to: dN do: [ :c |
          index := index + 1.
          (self at: index) printOn: aStream
                             width: width decimal: places.].
          aStream cr. ].
        g = groups
          ifFalse:[ aStream cr ].
      ]! !

!MatrixND methodsFor: 'private' stamp: 'jpwj 7/19/2001 10:46'!
convertIndex: anInteger
   "Answer aVector containing the indices associated
    with the index, anInteger"
    | next  vector last index offset |
    ((anInteger > self size) or: [anInteger < 1 ] )
      ifTrue: [ ^self error: 'Invalid index value'].
    last := dimensionVector size.
    vector := (Vector new: last ) atAllPut: 1.
    index := anInteger.
    1 to: offsetVector size do:[ :i |
        offset := (offsetVector at: i).
        index > offset
          ifTrue:[
            next := (index - 1) // offset + 1.
            vector at: i put: next.
            index := index - (next - 1 * offset). ].
        ].
    index = 0
        ifFalse:[ vector at: last put: index ].
    ^vector! !

!MatrixND methodsFor: 'private' stamp: 'jpwj 7/19/2001 10:47'!
dimensions: aVector offsets: offsets
   "Private - set the instance variables "
    dimensionVector := aVector.
    offsetVector := offsets! !

!MatrixND methodsFor: 'unclassified' stamp: 'jpwj 7/19/2001 10:49'!
computeIndex: aVector
   "answer the index of the element given by the indices in aVector"
    | index last |
    last := dimensionVector size.
    index := aVector at: last.
    1 to: offsetVector size do:[ :i |
        index := index + ( (aVector at: i) - 1 * (offsetVector at: i) )].
    ^index! !

!MatrixND methodsFor: 'unclassified' stamp: 'jpwj 7/19/2001 10:48'!
elementAt: aVector put: anObject
   "Replace the element at position given by the indices in aVector
    with anObject"
    self at: (self computeIndex: aVector) put: anObject.
    ^anObject! !


!MatrixND class methodsFor: 'aaReadMe' stamp: 'jpwj 7/19/2001 12:16'!
aaReadMe
   "MatrixND is used for Matrices with 3 or more dimensions.
    Access elements with method #elementAt: anIndexArray
    Replace elements with method #elementAt: anIndexArray put: anElement
    In either case anIndexArray contains the indices of the desired element.
    Storage order:  The indices for a (3 by 3 by 3) MatrixND
    are given below in the order the elements are stored.
Element
Position   Indices
  1        (1 1 1)
  2        (1 1 2)
  3        (1 1 3)
  4        (1 2 1)
  5        (1 2 2)
  6        (1 2 3)
  7        (1 3 1)
  8        (1 3 2)
  9        (1 3 3)
 10        (2 1 1)
 11        (2 1 2)
 12        (2 1 3)
 13        (2 2 1)
 14        (2 2 2)
 15        (2 2 3)
 16        (2 3 1)
 17        (2 3 2)
 18        (2 3 3)
 19        (3 1 1)
 20        (3 1 2)
 21        (3 1 3)
 22        (3 2 1)
 23        (3 2 2)
 24        (3 2 3)
 25        (3 3 1)
 26        (3 3 2)
 27        (3 3 3)
"! !

!MatrixND class methodsFor: 'instance creation' stamp: 'jpwj 7/19/2001 12:17'!
new: aVector
   "answer a new instance with dimensions from aVector"
    | size offsetVector |
    aVector size > 1
        ifFalse:[ ^self error: self class name,' insufficent dimension'].
    aVector size = 2
        ifTrue:[ ^Matrix new: aVector ].
    size := 1.
    offsetVector := Vector new: aVector size - 1.
    aVector size to: 1 by: -1 do:[ :index |
      (aVector at: index) > 0
        ifFalse:[
            ^self error: self class name,(aVector at: index) printString,
                ' invalid dimension']
        ifTrue:[
          size := size * (aVector at: index).
          index > 1
            ifTrue:[ offsetVector at: index - 1 put: size.]. ]. ].
    ^(super new: size) dimensions: aVector offsets: offsetVector! !

!MatrixND class methodsFor: 'instance creation' stamp: 'jpwj 7/19/2001 12:16'!
new: aVector contents: aCollection
    "Return new instance to the dimension in aVector
        with the contents of aCollection"
    ^(self new: aVector ) contents: aCollection! !


!SquareMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:28'!
diagonal   
    "Return the diagonal of an N x N  Matrix "   
    | diagonal |   
    diagonal := Vector new: self rows.   
    1 to: self rows do: [ :i |   
        diagonal at: i put: (self row: i col: i) ].   
    ^diagonal! !

!SquareMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:29'!
diagonal: aVector   
   "Place elements from aVector on the diagonal of an N x N  Matrix   
    Answer an error unless aVector size = rows = columns   
    otherwise answer aVector."   
    aVector size = self rows   
      ifFalse: [ ^self error: self class name,   
        ' diagonal: aVector wrong size' ].   
    1 to: self rows do: [ :i |   
        self row: i col: i put: (aVector at: i) ].   
    ^aVector! !

!SquareMatrix methodsFor: 'testing' stamp: 'jpwj 7/19/2001 11:36'!
isSymmetric   
    "Answer true it the matrix is symmetric else answer false.   
    A matrix is symmetric if it equals its transpose.   
    i.e. dimensions are N @ N   
        and element(i,j) = element(j,i) for i=1..N and j=1..N "   
    self rows = 1   
        ifTrue:[ ^true ].   
    2 to: self rows do:[ :r |   
        1 to: (r - 1) do:[ :c |   
            (self row: r col: c) = (self row: c col: r)   
                ifFalse:[ ^false ].   
        ].].   
    ^true! !

!SquareMatrix methodsFor: 'unclassified' stamp: 'jpwj 7/19/2001 11:36'!
determinant   
  "answer the determinant of the receiver"   
    ^self luDecomposition determinant! !

!SquareMatrix methodsFor: 'unclassified' stamp: 'jpwj 7/20/2001 11:24'!
gaussJordanInverse 
   "Answer the determinant of self. 
    Contents of self are REPLACED by the inverse. 
    The inverse formed using Gauss-Jordan technique with full pivoting." 
    | pivotIndex pivotFactor determinant indexCol indexRow 
      amax irow icol temp swap | 
    "Set up work vectors " 
    pivotIndex  := (Vector new: self rows) atAllPut: 0. 
    pivotFactor := (Vector new: self rows) atAllPut: 0. 
    determinant := 1.0. 
    indexCol := Vector new: self rows. 
    indexRow := Vector new: self rows. 
    " Start of main loop " 
    1 to: self columns do: [ :i | amax := 0. 
         "Find the pivot" 
      1 to: self rows do: [ :j | "over the rows" 
        (pivotIndex at: j) = 1 
          ifFalse: [ 
            1 to: self columns do: [ :k |  "over the columns" 
              (pivotIndex at: k) = 0 
                ifTrue: [ 
                  temp := (self row: j col: k ) pseudoAbs. 
                  temp > amax 
                    ifTrue: [ amax := temp. irow := j. icol := k ] 
                    ifFalse:[ 
                      (pivotIndex at: k) > 1 
                        ifTrue: [ self error: 'Singular Matrix']. ]. 
              ]. "end  (pivotIndex at: k) = 0 " 
           ]. "end of inner find pivot loop(k)." 
         ]. "endif (pivotIndex at: j)  = 1 " 
       ]. "end of outer find pivot loop(j)." 
    pivotIndex at: icol put: ((pivotIndex at: icol) + 1). 
      " interchange rows if necessary " 
    irow  = icol   " pivot found at irow,icol " 
      ifFalse: [ 
        determinant := determinant negated. 
        self row: irow exchange: icol.  ]. 
    indexCol at: i put: icol. 
    indexRow at: i put: irow. 
    ( self row: icol col: icol) = 0  "should be test for near zero" 
      ifTrue: [ self error: 'Singular Matrix']. 
    pivotFactor at: i put: (self row: icol col: icol). 
    determinant := determinant * (pivotFactor at: i). 
    self row: icol col: icol put: 1.0. 
      "divide pivot row by pivot element" 
    self onRow: icol times: (pivotFactor at: i) reciprocal 
          from: 1 to: self columns. 
      "Reduce non-pivot rows except for the pivot one" 
    1 to: self rows do: [ :ll | 
      ll  = icol 
        ifFalse: [ 
          swap := self row: ll col: icol. 
          self row: ll col: icol put: 0. 
          self onRow: ll addRow: icol times: swap negated 
                from: 1 to: self columns. 
          ]. "end ifTrue" 
      ]."end do:[ :ll " 
    ]. "End of main loop" 
      "Now unscramble the columns " 
    self columns to: 1 by: -1 do: [ :l | 
      irow := (indexRow at: l). 
      icol := (indexCol at: l). 
      irow  = icol 
        ifFalse: [ 
          self column: irow exchange: icol.  ]. ]. 
    ^determinant! !

!SquareMatrix methodsFor: 'unclassified' stamp: 'jpwj 7/19/2001 11:36'!
inverse   
  "answer the inverse of the receiver"   
    ^self luDecomposition inverse! !

!SquareMatrix methodsFor: 'unclassified' stamp: 'jpwj 7/19/2001 11:30'!
luDecomposition   
  "Answer an LuMatrix which is the LU decomposition of the receiver."   
    | luMatrix |   
    luMatrix := LuMatrix new: self rows @ self columns contents: self.   
    luMatrix luDecomposition. "implemented by subClass"   
    ^luMatrix! !

!SquareMatrix methodsFor: 'unclassified' stamp: 'jpwj 7/19/2001 11:29'!
reorderRowsBy: rowPermutations   
    "Exchange rows in self based a row number in rowPermutations. "

    | rowIndex swappedRows |   
    (rowPermutations size = self rows )   
      ifFalse: [   
        ^self error: self class name,' rowPermutations incorrect size' ].   
    swappedRows := rowPermutations copy.   
    1 to: self rows do: [ :row |   
        rowIndex := swappedRows at: row.   
        row = rowIndex   
            ifFalse:[ "exchange rows"   
                swappedRows at: row put: (swappedRows at: rowIndex).   
                swappedRows at: rowIndex put: rowIndex.   
                self row: row exchange: rowIndex ].   
        ].! !


!LuMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 10:56'!
rowPermutations   
        "Answer the value of rowPermutations."   
    ^rowPermutations! !

!LuMatrix methodsFor: 'unclassified' stamp: 'jpwj 7/19/2001 10:54'!
determinant   
  "answer the determinant of the receiver"   
    | rowIndex determinant |   
    determinant := signOfDeterminant.   
    1 to: self rows do: [ :row |   
        rowsExchanged   
            ifTrue: [ rowIndex := row ]   
            ifFalse:[ rowIndex := rowPermutations at: row.].   
        determinant := determinant * (self row: rowIndex col: row).].   
    ^determinant! !

!LuMatrix methodsFor: 'unclassified' stamp: 'jpwj 7/19/2001 10:55'!
improveSolutionFor: xVector with: bVector fromMatrix: aMatrix   
   "Answer an Vector that has improved solutions values for   
    the xVector given.  aMatrix points to the original matrix   
    from which this LuMatrix was produced and  bVector is the   
    right hand side vector for the equation:   
        aMatrix * xVector = bVector "   
    | xImproved residuals errorTerms |   
    xImproved := aMatrix * xVector.   
    residuals := xImproved - bVector.   
    errorTerms := self solveForVector: residuals.   
    xImproved := xVector - errorTerms.   
    ^xImproved! !

!LuMatrix methodsFor: 'unclassified' stamp: 'jpwj 7/19/2001 10:53'!
inverse   
   "Answer of inverse of the Matrix from which this LuMatrix   
    was computed."   
   | inverse identityVector |   
    self columns = self rows   
      ifFalse: [ ^self error: 'LuMatrix not N by N' ].   
    identityVector := (Vector new: self rows) atAllPut: 0.   
    inverse := Matrix new: self rows @ self columns.   
    "Solve for the inverse by columns"   
    1 to: self columns do:[ :col |   
        identityVector at: col put: 1.   
        col > 1 ifTrue: [ identityVector at: (col - 1 ) put: 0.].   
        inverse columnAt: col put: ( self solveForVector: identityVector). ].   
     ^inverse! !

!LuMatrix methodsFor: 'unclassified' stamp: 'jpwj 7/19/2001 10:56'!
lMatrix   
   "Answer the L matrix from this LU matrix."   
    | rowIndex  lMatrix |   
       "create the Lmatrix"   
    lMatrix := Matrix new: self rows @ self columns.   
      "Copy in the elements in the strict lower half of self   
       place 1 on the diagonal and zeros in the upper half"   
    1 to: self rows do:[ :row |   
        rowsExchanged   
            ifTrue: [ rowIndex := row ]   
            ifFalse:[ rowIndex := rowPermutations at: row.].   
        1 to: (row - 1) do:[ :column |   
            lMatrix row: row col: column   
                put: (self row: rowIndex col: column). ].   
        lMatrix row: row col: row put: 1.   
        row + 1 to: self columns do: [ :column |   
            lMatrix row: row col: column put: 0. ].].   
    ^lMatrix! !

!LuMatrix methodsFor: 'unclassified' stamp: 'jpwj 7/19/2001 10:50'!
luDecomposition   
    "Do the L U decomposition of the receiver, Message should be sent   
    by an instance of Matrix which is N x N (SquareMatrix)"   
     | pivotFactor scalingCandidate pivotElement   
       sum merit meritIndex columnIndex rowIndex |   
      "For speed, make sure elements are of class Float"   
    self contentsFloat.   
      "initialize variables and work vectors"   
    rowsExchanged := true. "rows are physically exchanged"   
    signOfDeterminant := 1.0.   
    pivotFactor  := Vector new: self rows.   
    rowPermutations  := Vector new: self rows.   
       "find and save the implicit scaling information "   
    1 to: self rows do:[ :row |   
        rowPermutations at: row put: row.   
        columnIndex := self indexOfMaximumAbsoluteValueOnRow: row   
                        from: 1 to: self columns.   
        scalingCandidate := (self row: row col: columnIndex) pseudoAbs.   
        scalingCandidate = 0   
            ifTrue: [ ^self error: self class name,' Singular Matrix'].   
        pivotFactor at: row put: (scalingCandidate reciprocal). ].   
    "Loop over all the columns for Crout's method"   
    1 to: self columns do: [ :col |   
      "Case I "   
        1 to: (col - 1) do: [ :i |   
          sum :=  self onRowSumProductsNegated: i downCol: col   
                        initialValue: (self row: i col: col)   
                        from: 1 to: (i - 1).   
          self row: i col: col put: sum. ].   
      "Case II "   
        pivotElement := 0.   
        col to: self rows do: [ :i |   
          sum :=  self onRowSumProductsNegated: i downCol: col   
                        initialValue: (self row: i col: col)   
                        from: 1 to: (col - 1).   
          self row: i col: col put: sum.   
          merit := (pivotFactor at: i) * (sum pseudoAbs).   
          merit >= pivotElement   
            ifTrue: [   
                meritIndex := i.   
                pivotElement := merit. ].  ]. "end col to: rows"   
      "Interchange rows?"   
      col = meritIndex   
        ifFalse: [ "Swap rows"   
            self row: meritIndex exchange: col.   
            rowIndex := rowPermutations at: col.   
            rowPermutations at: col put: meritIndex.   
            rowPermutations at: meritIndex put: rowIndex.   
            signOfDeterminant := signOfDeterminant negated.   
            pivotFactor at: meritIndex put: (pivotFactor at: col ).].   
      (self row: col col: col ) = 0 "Matrix is singular to precision   
            of algorithm.  Can substitute a small value e.g. 1.0e-20"   
         ifTrue: [ ^self error: self class name,' Singular Matrix'].   
      col  = self columns   
        ifFalse: [   
            merit := (self row: col col: col ) reciprocal.   
            self onColumn: col times: merit from: (col + 1) to: self rows. ].   
    ]. "end of big loop"! !

!LuMatrix methodsFor: 'unclassified' stamp: 'jpwj 7/19/2001 10:55'!
luDecompositionAlternate   
    "Perform LU decomposition on self.  This alternate method   
    is faster on larger matrices than luDecomposition method.   
    Howerver, luDecomposition is better on near singular matrices"   
    |   rowIndex columnIndex nextRow maxRowAbs maxAbs   
        pivotIndex pivotRow pivotElement tempElement multiplier |   
      "For speed, make sure elements are of class Float"   
    self contentsFloat.   
    signOfDeterminant := 1.0.   
    rowsExchanged := false. "rows are NOT physically exchanged"   
    maxRowAbs  := Vector new: self rows.   
    rowPermutations  := Vector new: self rows.   
      "Find the element on each row with maximum absolute value   
       and initialize  rowPermutations "   
    1 to: self rows do:[ :row |   
      rowPermutations at: row put: row.   
      columnIndex := self indexOfMaximumAbsoluteValueOnRow: row   
                        from: 1 to: self columns.   
      maxAbs  := (self row: row col: columnIndex) pseudoAbs.   
      maxAbs  = 0   
        ifTrue: [ ^self error: 'Singular Matrix'].   
      maxRowAbs at: row put: (maxAbs reciprocal). ].   
    " Main LU factorization loop   
            "   
    1 to: self columns - 1 do:[ :col |   
      pivotElement := 0.   
      col to: self columns do:[ :c |  "Find pivot element in col"   
        rowIndex := rowPermutations at: c.   
        maxAbs :=  (maxRowAbs at: rowIndex).   
        tempElement :=   
          ((self row: rowIndex col: col) pseudoAbs * maxAbs ).   
        tempElement > pivotElement   
            ifTrue:[ "save position information"   
                pivotRow := rowIndex.   
                pivotIndex := c.   
                pivotElement := tempElement. ]. ].   
     (rowPermutations at: col) = pivotRow   
        ifFalse:[ "exchange indexes (implied row exchange)"   
            signOfDeterminant := signOfDeterminant negated.   
            rowIndex := (rowPermutations at: col).   
            rowPermutations at: col put: (rowPermutations at: pivotIndex).   
            rowPermutations at: pivotIndex put: rowIndex. ].   
    (self row: pivotIndex col: col) = 0   
        ifFalse:[ "reduce elements in current column"   
            (col + 1) to: self rows do:[ :r |  "and adjust row values"   
                nextRow := rowPermutations at: r.   
                multiplier := (self row: nextRow col: col)   
                                / (self row: pivotRow col: col).   
                self onRow: nextRow   
                    addRow: pivotRow times: multiplier negated   
                    from: (col + 1) to: self columns.   
                self row: nextRow col: col put: multiplier. ].   
        ]. "end if pivot element zero"   
    ]. "end main LU factorization loop"! !

!LuMatrix methodsFor: 'unclassified' stamp: 'jpwj 7/19/2001 10:57'!
solveForMatrix: bMatrix   
  "Answer the solution matrix X for A * X = B where A is self   
    X is the solution matrix and B is the known matrix"   
   | xMatrix columnVector |   
    self columns = bMatrix rows   
      ifFalse: [ ^self error: 'bMatrix incorrect dimensions' ].   
    xMatrix := Matrix new: self rows @ bMatrix columns.   
    "Solve for the inverse by columns"   
    1 to: bMatrix columns do:[ :column |   
        columnVector := bMatrix columnAt: column.   
        xMatrix columnAt: column   
                     put: ( self solveForVector: columnVector). ].   
     ^xMatrix! !

!LuMatrix methodsFor: 'unclassified' stamp: 'jpwj 7/21/2001 07:54'!
solveForVector: aVector   
   "Answer the solution vector x for N linear equations A * x = b   
    where A is self(LuMatrix) and b is aVector"   
    | solutionVector firstNonzeroIndex rowIndex sum |   
    aVector size = self columns   
      ifFalse: [ self error: self class name,' aVector size incorrect.'].   
    solutionVector := aVector copy.   
    solutionVector == aVector ifTrue:[ self error: 'solution vector can not equal aVector.'].   
    "Forward solution "   
    firstNonzeroIndex := 0.   
    1 to: self rows do:[ :row |   
        rowIndex := rowPermutations at: row.   
        sum := aVector at: rowIndex.   
        rowsExchanged   
            ifTrue:[ rowIndex := row ].   
        firstNonzeroIndex = 0   
          ifFalse:[   
            firstNonzeroIndex to: ( row - 1 ) do:[ :j |   
            sum := sum - ((self row: rowIndex col: j) * (solutionVector at: j) ). ].]   
          ifTrue:[   
            sum = 0   
                ifFalse: [ firstNonzeroIndex := row ]. ].   
        solutionVector at: row put: sum. ].   
    "Back substitution "   
    self rows to: 1 by: -1 do:[ :row |   
        sum := solutionVector at: row.   
        rowsExchanged   
            ifTrue: [ rowIndex := row ]   
            ifFalse:[ rowIndex := rowPermutations at: row.].   
        row < self rows ifTrue:[   
            (row + 1) to: self columns do: [ :col |   
               sum := sum - ((self row: rowIndex col: col) * (solutionVector at: col)). ].].   
        solutionVector at: row put: (sum / (self row: rowIndex col: row )). ].   
    ^solutionVector! !

!LuMatrix methodsFor: 'unclassified' stamp: 'jpwj 7/19/2001 10:52'!
uMatrix   
   "Answer the U matrix from this LU matrix."   
    | rowIndex  uMatrix |   
       "create the uMatrix"   
    uMatrix := Matrix new: self rows @ self columns.   
      "Copy in elements and zero the strict lower half"   
    1 to: self rows do:[ :row |   
        rowsExchanged   
            ifTrue: [ rowIndex := row ]   
            ifFalse:[ rowIndex := rowPermutations at: row.].   
        row to: self columns do:[ :column |   
            uMatrix row: row col: column   
                put: (self row: rowIndex col: column). ].   
        1 to: (row - 1) do: [ :column |   
            uMatrix row: row col: column put: 0. ].].   
    ^uMatrix! !


!SquareMatrix class methodsFor: 'aaReadme' stamp: 'jpwj 7/19/2001 12:14'!
aaReadMe
   "This subclass holds the N @ N case of a Matrix and groups
    other subclasses that MUST be N @ N.  Matrix class creation
    methods automatically create this class when the dimensions
    are N @ N.  i.e. Matrix new: 4 @ 4 creates an instance of
    SquareMatrix dimensioned 4 @ 4. "! !

!SquareMatrix class methodsFor: 'instance creation' stamp: 'jpwj 7/19/2001 12:15'!
new: aPointOrInteger
   "Answer a new instance. Dimensions must be N by N.
    Matrix sends message to this class when dimensions are N @ N"
    | aPoint newMatrix |
    aPoint := Matrices2Dimensional convertToPoint: aPointOrInteger.
    aPoint x = aPoint y
      ifFalse:[^self error: self class name,' MUST be N @ N'].
    newMatrix := super basicNew: (aPoint x * (aPoint y)).
    newMatrix rows: aPoint x byColumns: aPoint y.
    ^newMatrix! !


!LuMatrix class methodsFor: 'aaReadMe' stamp: 'jpwj 7/19/2001 12:21'!
aaReadMe   
   "SquareMatrix subClass LuMatrix should ONLY be used to hold   
    the luDecomposition of a Matrix.  LuMatrix then can be used   
    to compute various items - see instance methods of LuMatrix. "! !


!String methodsFor: 'converting' stamp: 'jpwj 7/21/2001 11:10'!
asFloat
"Answer the Float value of the decimal number contained in self.
 Easily converted to answer a Fraction for the decimal number by
 removing references to asFloat   MathPack jpwj 6/1/89"
    | ePosition  whole fraction exponent period string sign |
    string := self asLowercase trimBlanks.
    ePosition := string indexOf: $e.
    ePosition > 0
        ifTrue:[
          exponent := string copyFrom: (ePosition + 1) to: string size.
          exponent := exponent asInteger.
          string := string copyFrom: 1 to: (ePosition - 1)]
        ifFalse:[ exponent := 0 ].
    period := string indexOf: $..

    period = 0
        ifTrue:[ "no period, convert to Integer then Float"
            whole := (string asInteger) asFloat.
            exponent ~= 0
                ifTrue:[ whole := whole * (10 raisedToInteger: exponent)].
            ^whole ].
    period = string size
        ifTrue:[ "no digits follow the period"
            string at: period put: $  .
            string := string trimBlanks.
            whole := (string asInteger) asFloat.
            exponent ~= 0
                ifTrue:[ whole := whole * (10 raisedToInteger: exponent)].
            ^whole ].
        "if sign is present, remove it and set sign = true/false.
         allows for the case -0.123"
    sign := false.
   ( (string at: 1) = $+ )
      ifTrue: [
        sign := false.
        string at: 1 put: $  .
        string := string trimBlanks.].
   ( (string at: 1) = $- )
      ifTrue: [
        sign := true.
        string at: 1 put: $  .
        string := string trimBlanks.].
    period := string indexOf: $..
    period = 1
        ifTrue:[ whole := 0 ]
        ifFalse:[ whole := string copyFrom: 1 to: (period - 1).
            whole := whole asInteger asFloat.].
    fraction := string copyFrom: (period + 1) to: string size.
    fraction := fraction asInteger asFloat
                    / (10 raisedToInteger: (string size - period)).
    whole := whole + fraction.
    exponent ~= 0
        ifTrue:[ whole := whole * (10 raisedToInteger: exponent) ].
    sign
      ifTrue:[ whole := whole negated ].
    ^whole! !

!String methodsFor: 'converting' stamp: 'jpwj 7/21/2001 11:09'!
removeLeadingAndTrailingCharacter: aCharacter
	"Remove all leading and trailing characters from the receiver that match aCharacter.
	Added jpwj 7/21/2001 11:09"

	| first last |
	first := 1.
	[ (first <= self size) and:[ (self at: first) = aCharacter] ] whileTrue:[ first := first + 1 ].
	first > self size
		ifTrue:[ ^self species new ].
	last := self size.
	[ (last > 1) and:[ (self at: last) = aCharacter] ] whileTrue:[ last := last - 1 ].
	^self copyFrom: first to: last! !

!String methodsFor: 'converting' stamp: 'jpwj 7/21/2001 11:08'!
trimBlanks
	"Answer a new string with leading and trailing spaces removed.
	Added jpwj 7/21/2001 11:07  "

	^self removeLeadingAndTrailingCharacter: Character space! !


!TriDiagonalMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:06'!
appendAtBottom: anArrayOrMatrix
   "Answer a new instance containing contents of self with
    anArrayOrMatrix contents appended to the right side.
    anArray size MUST equal self rows (i.e. column vector).
    aMatrix rows MUST equal self rows."
    ^self asMatrix appendAtBottom: anArrayOrMatrix! !

!TriDiagonalMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:09'!
appendAtRight: anArrayOrMatrix
   "Answer a new instance containing contents of self with
    anArrayOrMatrix contents appended to the right side.
    anArray size MUST equal self rows (i.e. column vector).
    aMatrix rows MUST equal self rows."
    ^self asMatrix appendAtRight: anArrayOrMatrix! !

!TriDiagonalMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:09'!
columnAt: columnNumber   
    "answer a Vector containing the elements of the column at columnNumber as an Vector"   
    | column |   
    column := Vector new: self rows.   
    column atAllPut: 0.   
    column at: columnNumber put: (self row: columnNumber col: columnNumber).   
    (columnNumber - 1) > 0   
        ifTrue:[   
            column at: columnNumber - 1   
                  put: (self row: columnNumber - 1 col: columnNumber).].   
    (columnNumber + 1) > self rows   
        ifFalse:[   
            column at: columnNumber + 1   
                    put: (self row: columnNumber + 1 col: columnNumber).].   
    ^column! !

!TriDiagonalMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:08'!
deleteColumn: anIntegerOrArray
   "Answer a new instance with the specific rows deleted."
    ^self asMatrix deleteColumn: anIntegerOrArray! !

!TriDiagonalMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 10:59'!
deleteRow: anIntegerOrArray
   "Answer a new instance with the specific rows deleted."
    ^self asMatrix deleteRow: anIntegerOrArray! !

!TriDiagonalMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:04'!
diagonal   
   "Answer aVector of the diagonal elements"   
    | aVector |   
    aVector := Vector new: self rows.   
    1 to: self rows do: [ :i |   
        aVector at: i put: ( self at: i).].   
    ^aVector! !

!TriDiagonalMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:07'!
diagonal: aVector   
   "Place elements from aVector on the diagonal of an N x N  Matrix   
    Answer an error unless aVector size = rows = columns   
    otherwise answer aVector."   
    aVector size = self rows   
      ifFalse: [ ^self error: self class name,   
        ' diagonal: aVector wrong size' ].   
    1 to: self rows do: [ :i |   
        self at: i put: ( aVector at: i).].   
    ^aVector! !

!TriDiagonalMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:01'!
insertColumns: numberOfColumns before: columnNumber
   "Answer a new instance with numberOfColumns inserted before columnNumber."

    ^self asMatrix insertColumns: numberOfColumns before: columnNumber! !

!TriDiagonalMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:14'!
insertRows: numberOfRows above: rowNumber
   "Answer a new instance with numberOfRows inserted above rowNumber"
    ^self asMatrix insertRows: numberOfRows above: rowNumber! !

!TriDiagonalMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:07'!
row: rowNumber col: columnNumber   
   "Answer the element at the given row & column"   
    (rowNumber < 1 or: [   
     rowNumber > self rows or:[   
     columnNumber < 1 or: [   
     columnNumber > self columns ]]])   
       ifTrue:[ ^self error: self class name,   
        ' row:col: INVALID row and/or column number.'].   
    rowNumber = columnNumber   
        ifTrue:[ ^self at: rowNumber].   
    (rowNumber - columnNumber) abs > 1   
        ifTrue:[ ^0 ].   
    rowNumber > columnNumber   
        ifTrue:[^self at: self rows + columnNumber ]   
        ifFalse:[^self at: 2 * self rows - 1 + rowNumber ]! !

!TriDiagonalMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:06'!
row: rowNumber col: columnNumber extractSubMatrix: dimensions
   "Answer the subMatrix of dimensions from self where
    rowNumber,columnNumber define the upper left corner"
    ^self asMatrix row: rowNumber col: columnNumber extractSubMatrix: dimensions! !

!TriDiagonalMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:07'!
row: rowNumber col: columnNumber placeSubMatrix: aMatrix
   "Replace the subMatrix in self with aMatrix where
    rowNumber,columnNumber define the upper left corner"
    ^self asMatrix row: rowNumber col: columnNumber placeSubMatrix: aMatrix
! !

!TriDiagonalMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 10:58'!
rowAt: rowNumber
    "answer a Vector containing the elements of the row at rowNumber as an Vector"
    | row |
    row := Vector new: self columns.
    row atAllPut: 0.
    row at: rowNumber put: (self row: rowNumber col: rowNumber).
    (rowNumber - 1) > 0
        ifTrue:[
            row at: rowNumber - 1
                  put: (self row: rowNumber col: rowNumber - 1).].
    (rowNumber + 1) > self rows
        ifFalse:[
            row at: rowNumber + 1
                    put: (self row: rowNumber col: rowNumber + 1).].
    ^row! !

!TriDiagonalMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:00'!
subdiagonal   
   "Answer aVector of the subdiagonal elements   
    aVector size will be (rows - 1)."   
    | aVector |   
    aVector := Vector new: self rows - 1.   
    1 to: self rows - 1 do: [ :i |   
        aVector at: i put: ( self at: (self rows + i)).].   
    ^aVector! !

!TriDiagonalMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 10:58'!
subdiagonal: aVector   
   "Place the contents of aVector in the subdiagonal element positions.   
    aVector size = rows then the first element in aVector is ignored.   
    aVector size = (rows -1) then all elements in aVector are stored."   
    | start stop bias |   
    aVector size = self rows   
      ifTrue: [ start := 2. stop := self rows. bias := -1.]   
      ifFalse: [   
        stop := self rows - 1.   
        aVector size = stop   
            ifTrue: [ start := 1.  bias := 0.]   
            ifFalse:[   
^self error: self class name,' subdiagonal: aVector wrong size' ].].   
    start to: stop do: [ :i |   
        self at: (self rows + i + bias) put: ( aVector at: i).].   
    ^aVector! !

!TriDiagonalMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:08'!
subdiagonalN   
   "Answer aVector of the subdiagonal elements where   
    aVector size = rows and the first element in aVector is zero   
    and elements 2 to rows are the subdiagonal."   
    | aVector |   
    aVector := Vector new: self rows.   
    1 to: self rows - 1 do: [ :i |   
        aVector at: i + 1 put: ( self at: (self rows + i)).].   
    aVector at: 1 put: 0.   
    ^aVector! !

!TriDiagonalMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:04'!
superdiagonal   
   "Answer aVector of the superdiagonal elements   
    aVector size will be (rows - 1)."   
    | aVector index |   
    index := 2 * self rows - 1.   
    aVector := Vector new: self rows - 1.   
    1 to: self rows - 1 do: [ :i |   
        aVector at: i put: ( self at: (index + i)).].   
    ^aVector! !

!TriDiagonalMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:00'!
superdiagonal: aVector   
   "Place the contents of aVector in the superdiagonal element positions.   
    aVector size = rows then the last element in aVector is ignored.   
    aVector size = (rows -1) then all elements in aVector are stored."   
    | index stop |   
    index := 2 * self rows - 1.   
    stop := self rows - 1.   
    aVector size = self rows   
      ifFalse: [   
        aVector size = stop   
            ifFalse:[   
^self error: self class name,' subdiagonal: aVector wrong size' ].].   
    1 to: stop do: [ :i |   
        self at: (index + i) put: ( aVector at: i).].   
    ^aVector! !

!TriDiagonalMatrix methodsFor: 'accessing' stamp: 'jpwj 7/19/2001 11:09'!
superdiagonalN   
   "Answer aVector of the superdiagonal elements with   
    aVector size = rows.  The superdiagonal elements will be placed   
    in positions 1 to rows - 1 in aVector with aVector at: rows   
    set to zero."   
    | aVector index |   
    index := 2 * self rows - 1.   
    aVector := Vector new: self rows.   
    1 to: self rows - 1 do: [ :i |   
        aVector at: i put: ( self at: (index + i)).].   
    aVector at: self rows put: 0.0.   
    ^aVector! !

!TriDiagonalMatrix methodsFor: 'arithmetic' stamp: 'jpwj 7/23/2001 09:32'!
* aScalarVectorOrMatrix
   "Answer the result of self * aScalarVectorOrMatrix.
    result may be Scalar, Vector, Matrix.
    Select the appropiate method for the class of aScalarVectorOrMatrix
    timesScalar: is provided to operation on contents of self."
    | newMatrix |
 "aScalarVectorOrMatrix is a Scalar?"
    aScalarVectorOrMatrix isScalar
      ifTrue: [
        newMatrix := self species new: self dimensions.
        ^self timesScalar: aScalarVectorOrMatrix result: newMatrix ].
  "aScalarVectorOrMatrix is an Vector?
        vector treated as Matrix of dimensions (vector size @ 1)"
    ( aScalarVectorOrMatrix isVector )
      ifTrue:[ ^self asMatrix timesVector: aScalarVectorOrMatrix ].
  "aScalarVectorOrMatrix is aMatrix"
   (aScalarVectorOrMatrix is2DMatrix)
      ifFalse: [
        ^self error: self class name,' *  an invalid object' ].
    ^self asMatrix timesMatrix: aScalarVectorOrMatrix! !

!TriDiagonalMatrix methodsFor: 'arithmetic' stamp: 'jpwj 7/23/2001 09:33'!
+ aScalarOrMatrix
   "When aScalarOrMatrix is:
        aScalar answer self asMatrix + aScalarOrMatrix
        aMatrix of same class answer self plusMatrix:result:
        aMatrix of different class
                answer self asMatrix + aScalarOrMatrix asMatrix"
    | newMatrix |
  "Is aScalarOrMatrix a scalar?"
    aScalarOrMatrix isScalar
      ifTrue: [
        ^self asMatrix + aScalarOrMatrix].
  "Is aScalarOrMatrix a Matrix ?"
   (aScalarOrMatrix is2DMatrix)
      ifFalse: [
        ^self error: self class name,' +  with invalid object' ].
  "Is size of Matrix correct?"
    self checkForEqualDimensions: aScalarOrMatrix.
  "aScalarOrMatrix class same class as self?"
    self class ==  aScalarOrMatrix class
      ifFalse:[ "coerce both objects to full Matrix"
        ^self asMatrix + aScalarOrMatrix asMatrix ].
  "Same class"
    newMatrix := self species new: self dimensions.
    ^self plusMatrix: aScalarOrMatrix result: newMatrix! !

!TriDiagonalMatrix methodsFor: 'arithmetic' stamp: 'jpwj 7/23/2001 09:33'!
- aScalarOrMatrix
   "When aScalarOrMatrix is:
        aScalar answer self asMatrix - aScalarOrMatrix
        aMatrix of same class answer self plusMatrix:result:
        aMatrix of different class
                answer self asMatrix - aScalarOrMatrix asMatrix"
    | newMatrix |
  "Is aScalarOrMatrix a scalar?"
    aScalarOrMatrix isScalar
      ifTrue: [
        ^self asMatrix - aScalarOrMatrix].
  "Is aScalarOrMatrix a Matrix ?"
   (aScalarOrMatrix is2DMatrix)
      ifFalse: [
        ^self error: self class name,' -  with invalid object' ].
  "Is size of Matrix correct?"
    self checkForEqualDimensions: aScalarOrMatrix.
  "aScalarOrMatrix class same class as self?"
    self class ==  aScalarOrMatrix class
      ifFalse:[ "coerce both objects to full Matrix"
        ^self asMatrix - aScalarOrMatrix asMatrix ].
  "Same class"
    newMatrix := self species new: self dimensions.
    ^self minusMatrix: aScalarOrMatrix result: newMatrix! !

!TriDiagonalMatrix methodsFor: 'arithmetic-private' stamp: 'jpwj 7/19/2001 11:13'!
minus: aScalarOrMatrix
   "If aScalarOrMatrix class not equal self class then
    invalid message because class of reciever must change"
    self class ==  aScalarOrMatrix class
      ifFalse:[
        ^self error: 'Inapproicate message' ].
   "Is size of Matrix correct?"
    self checkForEqualDimensions: aScalarOrMatrix.
    ^self minusMatrix: aScalarOrMatrix result: self! !

!TriDiagonalMatrix methodsFor: 'converting' stamp: 'jpwj 7/19/2001 10:59'!
asMatrix   
   "Answer a full matrix "   
    | fullMatrix |   
    fullMatrix := Matrix new: self dimensions.   
    1 to: self rows do:[ :i |   
        fullMatrix rowAt: i put: (self rowAt: i) ].   
    ^fullMatrix! !

!TriDiagonalMatrix methodsFor: 'printing' stamp: 'jpwj 7/23/2001 08:51'!
printOn: aStream
	"Append the ASCII representation of the receiver to aStream.
	Printed out as diagonal, subdiagonal, superdiagonal.
		Method does not prevent prevent infinite recursion."
    | limit index stop |
    self isEmpty
        ifTrue: [
            nil printOn: aStream.
            ^self ].
    limit := aStream position + self printLimit.
    aStream nextPut: $(; cr; space.
    index := 0.
    1 to:    3 do: [ :r |
        r > 1
            ifTrue:[ stop := self rows - 1.]
            ifFalse:[ stop := self rows.].
    1 to: stop do: [ :c |
        (aStream position > limit)
            ifTrue: [
                '...etc...)' printOn: aStream.
                ^self].
        index := index + 1.
        (self at: index) printOn: aStream.
        aStream space].
        r ~= self rows
            ifTrue: [aStream cr; space. ]. ].
    aStream nextPut: $)! !

!TriDiagonalMatrix methodsFor: 'printing' stamp: 'jpwj 7/19/2001 11:09'!
printOn: aStream width: width decimal: places
    "Printed out as diagonal, subdiagonal, superdiagonal.
    with elements sized to width with decimal places"
    | index stop |
    aStream cr.
    index := 0.
    1 to: 3 do:[ :r |
      r > 1
        ifTrue:[ stop := self rows - 1]
        ifFalse:[ stop := self rows ].
      1 to: stop do:[ :c |
        index := index + 1.
        (self at: index) printOn: aStream
                           width: width decimal: places.].
      aStream cr. ]! !

!TriDiagonalMatrix methodsFor: 'testing' stamp: 'jpwj 7/19/2001 11:03'!
isSymmetric   
    "Answer true if the elements of the subdiagonal   
    equal to the corresponding elements superdiagonal"   
    | index1 index2 |   
    index1 := self rows.   
    index2 := 2 * self rows - 1.   
    1 to: self rows - 1 do:[ :i |   
        index1 := index1 + 1.   
        index2 := index2 + 1.   
        (self at: index1) = (self at: index2)   
            ifFalse:[ ^false ]. ].   
    ^true! !


!TriDiagonalMatrix class methodsFor: 'aaReadme' stamp: 'jpwj 7/19/2001 12:10'!
aaReadMe
   "TriDiagonalMatrix holds ONLY the three diagonals of
an N by N matrix to reduce memory storage requirements.
  Example of a 5 by 5 TriDiagonalMatrix
     d u 0 0 0
     l d u 0 0        d - diagonal elements
     0 l d u 0        l - subdiagonal elements
     0 0 l d u        u - superdiagonal elements
     0 0 0 l d
By definition all elements not on one of the diagonals is zero.
Define as a subclass of Matrices2Dimensional since its primary purpose of
to hold information for retrieval and should not inherited
standard Matrix manipulation methods.
    The    diagonal elements(d) in position 1 to N,
        subdiagonal elements(l) in position N + 1 to 2*N - 1 ,
      superdiagonal elements(u) in 2*N - 1 to 3*N - 2.
            where N = rows = columns of the TriDiagonalMatrix.
The method diagonal returns an Vector of size N.
Methods subdiagonal and superdiagonal return an Vector of size N - 1.
Methods subdiagonal: and superdiagonal: will accept an Vector of size N
with the following convention.
  subdiagonal: The first position in an Vector is ingored.
  superdiagonal: The last position in the Vector is ingored.
    "! !

!TriDiagonalMatrix class methodsFor: 'instance creation' stamp: 'jpwj 7/19/2001 12:12'!
new: aPointOrInteger
   "Answer a new instance. Dimensions must be N by N. "
    | aPoint newMatrix |
    aPoint := Matrices2Dimensional convertToPoint: aPointOrInteger.
    aPoint x = aPoint y
      ifFalse:[^self error: self class name,' MUST be N @ N'].
    aPoint x > 1
      ifFalse: [ ^self error: self class name,' insufficent dimensions.' ].
    newMatrix := super basicNew: (3 * (aPoint y) - 2).
    newMatrix rows: aPoint x byColumns: aPoint y.
    ^newMatrix! !

!TriDiagonalMatrix class methodsFor: 'instance creation' stamp: 'jpwj 7/19/2001 12:12'!
new: dimensions contents: aVector   
   "Answer a new instance of TriDiagonalMatrix with the contents   
    of aVector.  aVector size must equal 2 * rows - 2 where   
    the first rows elements are the diagonal, the next (rows-1)   
    elements are the subdiagonal, and the last (rows-1) elements   
    are for the superdiagonal."   
    ^(self new: dimensions ) contents: aVector! !


!Vector methodsFor: 'arithmetic' stamp: 'jpwj 7/23/2001 09:27'!
* aScalarVectorOrMatrix
   "Answer new instance equal to self * aScalarVectorOrMatrix
    Operation performs element wise multiplication for
    a scalar or another vector of correct size.
    NOTE: When aScalarVectorOrMatrix is a Matrix,
        self MUST contain ONLY scalar values (no nil values).
    Method times: does operation on contents of self
                  for aScalar or aVector.
    If aScalarVectorOrMatrix is a scalar or vector, then nil elements
    are allowed and the (answerVector at: anIndex) is set to nil if the
    corresponding element in self or vector is nil."
    |  answer |
 "Is aScalarVectorOrMatrix a scalar?"
    aScalarVectorOrMatrix isScalar
      ifTrue:[
        answer := Vector new: self size.
        ^self timesScalar: aScalarVectorOrMatrix
                   result: answer  ].
 "Is aScalarVectorOrMatrix a Vector ?"
    (aScalarVectorOrMatrix isVector )
      ifTrue:[ "Same size?"
        (self size = aScalarVectorOrMatrix size )
          ifFalse: [
            ^self error: self class name,' *  wrong size Vector' ].
        answer := Vector new: self size.
        ^self timesVector: aScalarVectorOrMatrix
              result: answer  ].
 "Is aScalarVectorOrMatrix a Matrix ?"
    (aScalarVectorOrMatrix is2DMatrix )
      ifTrue:[ "self is considered a 1 @ self size matrix"
         ^self timesMatrix: aScalarVectorOrMatrix ].
    ^self error: self class name,' * invalid object'! !

!Vector methodsFor: 'arithmetic' stamp: 'jpwj 7/23/2001 09:27'!
+ aScalarOrVector
   "Answer a new instance equal to self + aScalarOrVector
    where aScalarOrVector is either a scalar or another vector.
    element wise addition
    Method plus: does operation on contents of self.
    If aScalarOrVector is a scalar or vector, then nil elements
    are allowed and the (answerVector at: anIndex) is set to nil if the
    corresponding element in self or vector is nil."
    | newVector |
 "Is aScalarOrVector a scalar?"
    aScalarOrVector isScalar
      ifTrue: [
        newVector := Vector new: self size.
        ^self plusScalar: aScalarOrVector result: newVector ].
 "Is aScalarOrVector an Vector ?"
    (aScalarOrVector isVector )
      ifFalse: [
        ^self error: self class name,' + invalid object' ].
   "Same size?"
    (self size = aScalarOrVector size )
      ifFalse: [
        ^self error: self class name,' + wrong size Vector' ].
    newVector := Vector new: self size.
    ^self plusVector: aScalarOrVector result: newVector! !

!Vector methodsFor: 'arithmetic' stamp: 'jpwj 7/23/2001 09:28'!
- aScalarOrVector
   "Answer a new instance of self - aScalarOrVector
    where aScalarOrVector is either a scalar or vector.
    element wise subtraction.
    Method minus: does operation on contents of self.
    If aScalarOrVector is a scalar or vector, then nil elements
    are allowed and the (answerVector at: anIndex) is set to nil if the
    corresponding element in self or vector is nil."
    | newVector |
 "Is aScalarOrVector a scalar?"
    aScalarOrVector isScalar
      ifTrue: [
        newVector := Vector new: self size.
        ^self minusScalar: aScalarOrVector result: newVector ].
 "Is aScalarOrVector an Vector ?"
    (aScalarOrVector isVector)
      ifFalse: [
        ^self error: self class name,' - invalid object' ].
   "Same size?"
    (self size = aScalarOrVector size )
      ifFalse: [
        ^self error: self class name,' -  wrong size Vector' ].
    newVector := Vector new: self size.
    ^self minusVector: aScalarOrVector result: newVector! !

!Vector methodsFor: 'arithmetic' stamp: 'jpwj 7/19/2001 12:02'!
crossProduct: aVector
   "Answer a Matrix which contains the cross product of self by aVector.
    self and aVector MUST contain NO nil elements.
    Matrix will be dimensioned (self size) @ (aVector size).
    self is treated as a Matrix dimensioned (self size) @ 1,
    i.e. column vector.  aVector is treated as a Matrix dimensioned
    1 @ (aVector size), i.e. row vector.  An alternate but slower method
    is to make both self & aVector a Matrix then multiple them.
    For example:
        a := Matrix new: (self size) @ 1 contents: self.
        b := Matrix new: 1 @ (aVector size) contents: aVector.
        ^(a * b)      "
      | rows columns matrix index |
    rows := self size.  columns := aVector size.
    matrix := Matrix new: rows @ columns.
    index := 0.
    1 to: rows do: [ :i |
        1 to: columns do: [ :j |
            index := index + 1.
            matrix at: index put: ((self at: i) * (aVector at: j)) ]. ].
    ^matrix! !

!Vector methodsFor: 'arithmetic' stamp: 'jpwj 7/19/2001 12:02'!
dotProduct: aVector
   "Answer 0 if noElements
    Else answer the sum of products taken element wise
    self and aVector MUST contain NO nil elements"
    | sumOfProducts |
    self size = aVector size
      ifFalse:[
       ^self error: 'Vector sizes not equal.' ].
    sumOfProducts := 0.
    self doIndex:[ :x :index |
         sumOfProducts := sumOfProducts + (x * (aVector at: index)).].
    ^sumOfProducts! !

!Vector methodsFor: 'arithmetic-private' stamp: 'jpwj 7/23/2001 09:28'!
minus: aScalarOrVector
   "changes the elements in self to self - aScalarOrVector
    where aScalarOrVector is either a scalar or another vector.
    element wise subtraction.
    If aScalarOrVector is a scalar or vector, then nil elements
    are allowed and the (answerVector at: anIndex) is set to nil if the
    corresponding element in self or vector is nil."
 "Is anObject a scalar?"
    aScalarOrVector isScalar
      ifTrue: [
        ^self minusScalar: aScalarOrVector result: self].
 "Is anObject a Vector ?"
    (aScalarOrVector isVector )
      ifFalse: [
        ^self error: self class name,' - invalid object' ].
   "Same size?"
    (self size = aScalarOrVector size )
      ifFalse: [
        ^self error: self class name,' -  wrong size Vector' ].
    ^self minusVector: aScalarOrVector result: self! !

!Vector methodsFor: 'arithmetic-private' stamp: 'jpwj 7/20/2001 09:04'!
plusVector: aVector times: aScalar 
   "Answer self after adding to each element in self the 
    corresponding elements in aVector times aScalar.  i.e. 
    e = e + (a * s)  where e is (self at: i), a is (aVector at: i) 
    and s is aScalar for i = 1 to self size. 
       To subtract (a * s) instead of adding use aScalar negated." 
    | index | 
      "Is aScalar a scalar?" 
    aScalar isScalar 
      ifFalse: [ 
        ^self error: self class name,' not aScalar.' ]. 
      "Is aVector the correct size?" 
    (self size = aVector size ) 
      ifFalse: [ 
        ^self error: self class name,' aVector is wrong size.' ]. 
    index := 0. 
    self do: [ :x | 
        index := index + 1. 
        (x isNil or:[ (aVector at: index) isNil]) 
          ifFalse: [ 
            self at: index 
                put: (x + ((aVector at: index) * aScalar)).].  ]. 
    ^self! !

!Vector methodsFor: 'arithmetic-private' stamp: 'jpwj 7/23/2001 09:28'!
times: aScalarOrVector
   "change contents of self to self * aScalarOrVector
    Operation performs element wise multiplication for
    a scalar or another vector of correct size.
    If aScalarOrVector is a scalar or vector, then nil elements
    are allowed and the (answerVector at: anIndex) is set to nil if the
    corresponding element in self or vector is nil."

 "Is aScalarOrVector a scalar?"
    aScalarOrVector isScalar
      ifTrue: [
        ^self timesScalar: aScalarOrVector result: self  ].
 "Is anObject an Vector ?"
    (aScalarOrVector isVector)
      ifFalse: [
        ^self error: self class name,' * invalid object' ].
   "Same size?"
    (self size = aScalarOrVector size )
      ifFalse: [
        ^self error: self class name,' *  wrong size Vector' ].
    ^self timesVector: aScalarOrVector result: self! !

!Vector methodsFor: 'testing' stamp: 'jpwj 7/23/2001 09:17'!
isVector
	"Answer true"

	^true! !


!SquareMatrix reorganize!
('accessing' copyLowerHalfFrom: copyLowerHalfToUpperHalf diagonal diagonal: eigenvalues eigenvectors transformation:)
('EigenSystem' jacobiEigenSystem)
('private' eigenvalues: eigenvectors:)
('testing' isSymmetric)
('unclassified' determinant gaussJordanInverse inverse jacobiTransformation luDecomposition realSymmetricEigenSystem: reduceToTriDiagonal: reorderRowsBy: sortEigenSystem:)
!


!Matrix reorganize!
('accessing' columnAt: columnAt:put: indexOfMaximumAbsoluteValueOnColumn:from:to: indexOfMaximumAbsoluteValueOnRow:from:to: row:col: row:col:put: row:exchange: rowAt: rowAt:put:)
('arithmetic' * crossProduct:with: dotProductConjugateOfColumn:with:from:to: dotProductConjugateOfRow:with:from:to: dotProductOfColumn:with:from:to: dotProductOfRow:with:from:to: sumAbsoluteValuesOnColumn:from:to: sumAbsoluteValuesOnRow:from:to:)
('arithmetic-private' minus: onColumn:addColumn:times:from:to: onColumn:times:from:to: onRow:addRow:times:from:to: onRow:times:from:to: onRowSumProductsNegated:downCol:initialValue:from:to: plus: timesMatrix: timesVector:)
('converting' convertIndex: convertPoint:)
('copying' copyRow:fromMatrix:start:stop:toRow: copyRow:fromMatrix:toRow: copyRow:fromMatrix:toRow:at:)
('printing' printOn: printOn:width:decimal:)
('private' computeIndexFor:at:)
('testing' isSymmetric)
('unclassified' column:exchange: transpose)
!

Matrices2Dimensional removeSelector: #indexOfMaximumAbsoluteValueOnColumn:from:to:!
Matrices2Dimensional removeSelector: #row:col:!

!Matrices class reorganize!
('aaReadMe' aaReadMe)
('constants' printLimit)
('examples' exampleReadMe)
('instance creation' new)
!

